#import "ButtonFullScreen.h"

@implementation ButtonFullScreen
//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	// delete focus ring
//	[self setFocusRingType:NSFocusRingTypeNone];

	[self setEnabled:NO];

	// set notification
	NSNotificationCenter *nc=[NSNotificationCenter defaultCenter];
	[nc addObserver:self selector:@selector(handleVideoObjectDidChanged:) name:VIDEO_NOTIF_OBJECT_DID_CHANGED object:nil];
	[nc addObserver:self selector:@selector(handleFullScreenDidChanged:) name:WINDOW_NOTIF_FULLSCREEN_DID_CHANGED object:nil];

}
//------------------------------------
// handleVideoObjectDidChanged
//------------------------------------
- (void)handleVideoObjectDidChanged:(NSNotification *)notification
{
	BOOL hasVideoId = [[[notification object] valueForKey:@"hasVideoId"] boolValue];
	[self setEnabled:hasVideoId];
}
//------------------------------------
// handleFullScreenDidChanged
//------------------------------------
- (void)handleFullScreenDidChanged:(NSNotification *)notification
{
	BOOL isFullScreen = [[notification object] boolValue];

	NSImage *image = nil;

	if(isFullScreen == NO){
		image = [NSImage imageNamed:@"btn_window_full_on"];
	}else{
		image = [NSImage imageNamed:@"btn_window_full_off"];
	}

	[self setImage:image];
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[[NSNotificationCenter defaultCenter] removeObserver:self];

	[super dealloc];
}

@end
