#import "ButtonMaximizePlayer.h"

@implementation ButtonMaximizePlayer
//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	// delete focus ring
//	[self setFocusRingType:NSFocusRingTypeNone];

	[self setEnabled:NO];
	[self changeButtonImage:NO];

	// set notification
	NSNotificationCenter *nc=[NSNotificationCenter defaultCenter];
	[nc addObserver:self selector:@selector(handleVideoObjectDidChanged:) name:VIDEO_NOTIF_OBJECT_DID_CHANGED object:nil];
	[nc addObserver:self selector:@selector(handlePlayerMaximizeEnableDidChanged:) name:PLAYER_NOTIF_MAXIMIZE_ENABLE_DID_CHANGED object:nil];
	[nc addObserver:self selector:@selector(handlePlayerMaximizeDidChanged:) name:PLAYER_NOTIF_MAXIMIZE_DID_CHANGED object:nil];

}
//------------------------------------
// changeButtonImage
//------------------------------------
- (void)changeButtonImage:(BOOL)isMaximize
{
	NSImage *btnImage;

	if(isMaximize == YES){
		btnImage = [NSImage imageNamed:@"btn_maximize_on"];
	}else{
		btnImage = [NSImage imageNamed:@"btn_maximize_off"];
	}

	[self setImage:btnImage];

}
//------------------------------------
// handleVideoObjectDidChanged
//------------------------------------
- (void)handleVideoObjectDidChanged:(NSNotification *)notification
{
	BOOL canChangeMaximize = [[[notification object] valueForKey:@"canChangeMaximize"] boolValue];
	if(canChangeMaximize == NO){
		[self changeButtonImage:canChangeMaximize];
		[self setEnabled:canChangeMaximize];
	}
}
//------------------------------------
// handleVideoObjectDidChanged
//------------------------------------
- (void)handlePlayerMaximizeEnableDidChanged:(NSNotification *)notification
{
	[self setEnabled:[[notification object] boolValue]];
}
//------------------------------------
// handlePlayerMaximizeDidChanged
//------------------------------------
- (void)handlePlayerMaximizeDidChanged:(NSNotification *)notification
{
	int state = [[notification object] intValue];

	BOOL isMaximize;

	if(state == 1){
		isMaximize = YES;
	}else{
		isMaximize = NO;
	}

	[self changeButtonImage:isMaximize];

}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[[NSNotificationCenter defaultCenter] removeObserver:self];

	[super dealloc];
}

@end
