#import "ButtonMaximizePreview.h"

@implementation ButtonMaximizePreview
//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	// delete focus ring
//	[self setFocusRingType:NSFocusRingTypeNone];

	[self setEnabled:NO];
	[self setIsMaximizedHeight:NO];
	[self setIsMaximizedWidth:NO];
	[self changeButtonImage];

	// set notification
	NSNotificationCenter *nc=[NSNotificationCenter defaultCenter];
	[nc addObserver:self selector:@selector(handlePreviewSizeDidChanged:) name:PREVIEW_NOTIF_SIZE_DID_CHANGED object:nil];
	[nc addObserver:self selector:@selector(handlePreviewIndexDidChanged:) name:PREVIEW_NOTIF_INDEX_DID_CHANGED object:nil];

}
//------------------------------------
// changeButtonImage
//------------------------------------
- (void)changeButtonImage
{
	NSImage *btnImage;

	if([self isMaximizedWidth] == YES && [self isMaximizedHeight] == YES){
		btnImage = [NSImage imageNamed:@"btn_maximize_on"];
	}else{
		btnImage = [NSImage imageNamed:@"btn_maximize_off"];
	}

	[self setImage:btnImage];

}
//------------------------------------
// handlePreviewIndexDidChanged
//------------------------------------
- (void)handlePreviewIndexDidChanged:(NSNotification *)notification
{
	int index = [[notification object] intValue];
	if(index == PREVIEW_TAB_INDEX_PREVIEW){
		[self setEnabled:YES];
	}else{
		[self setEnabled:NO];
	}

}
//------------------------------------
// handlePreviewSizeDidChanged
//------------------------------------
- (void)handlePreviewSizeDidChanged:(NSNotification *)notification
{
	NSDictionary *params = [notification object];

	BOOL isVertical = [[params valueForKey:@"isVertical"] boolValue];
	BOOL isMaximized = [[params valueForKey:@"isMaximized"] boolValue];
//	NSLog(@"isVertical=%d isMaximized=%d", isVertical, isMaximized);

	if(isVertical == YES){
		[self setIsMaximizedWidth:isMaximized];
	}else{
		[self setIsMaximizedHeight:isMaximized];
	}

	[self changeButtonImage];

}
//------------------------------------
// isMaximizedWidth
//------------------------------------
- (void)setIsMaximizedWidth:(BOOL)isMaximizedWidth
{
	isMaximizedWidth_ = isMaximizedWidth;
}
- (BOOL)isMaximizedWidth
{
	return isMaximizedWidth_;
}
//------------------------------------
// isMaximizedHeight
//------------------------------------
- (void)setIsMaximizedHeight:(BOOL)isMaximizedHeight
{
	isMaximizedHeight_ = isMaximizedHeight;
}
- (BOOL)isMaximizedHeight
{
	return isMaximizedHeight_;
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[[NSNotificationCenter defaultCenter] removeObserver:self];

	[super dealloc];
}

@end
