#import "ButtonShowComment.h"
#import "UserDefaultsExtension.h"

static NSString *defaultKey = @"optNicoPlayerShowInputArea";

@implementation ButtonShowComment
//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	// delete focus ring
//	[self setFocusRingType:NSFocusRingTypeNone];

	[self setEnabled:NO];
	[self changeButtonImage];

	// add observer
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults addObserver:self forKeyPath:defaultKey options:0 context:nil];

	// set notification
	NSNotificationCenter *nc=[NSNotificationCenter defaultCenter];
	[nc addObserver:self selector:@selector(handleVideoObjectDidChanged:) name:VIDEO_NOTIF_OBJECT_DID_CHANGED object:nil];

}
//------------------------------------
// changeButtonImage
//------------------------------------
- (void)changeButtonImage
{
	NSImage *btnImage;

	if([self defaultBoolValue:defaultKey] == YES){
		btnImage = [NSImage imageNamed:@"btn_comment_on"];
	}else{
		btnImage = [NSImage imageNamed:@"btn_comment_off"];
	}

	[self setImage:btnImage];

}
//------------------------------------
// handleVideoObjectDidChanged
//------------------------------------
- (void)handleVideoObjectDidChanged:(NSNotification *)notification
{
	BOOL canChangeComment = [[[notification object] valueForKey:@"canChangeComment"] boolValue];
	[self setEnabled:canChangeComment];
}
//------------------------------------
// observeValueForKeyPath
//------------------------------------
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
	if([keyPath isEqualToString:defaultKey]){
		[self changeButtonImage];
	}
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	[[NSUserDefaults standardUserDefaults] removeObserver:self forKeyPath:defaultKey];

	[super dealloc];
}

@end
