#import "CMSearchlistHeader.h"
#import "SearchlistTableView.h"

@implementation CMSearchlistHeader

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	//set delegate parent menu
	[super setDelegate: self ];

}
//------------------------------------
// set Menu Item
//------------------------------------
-(void)setMenuItem
{

	NSArray *cols;
	NSString *title;
	NSString *identifier;
	NSString *senderString;
	int state;
	id record;

	// remove all items
    NSEnumerator *enumItemArray = [[self itemArray] objectEnumerator];
    while (record = [enumItemArray nextObject]) {
		[self removeItem:record];
	}

	// add item 
    NSEnumerator *enumColArray = [[self menuItems] objectEnumerator];
	NSMenuItem *menuItem;

    while (record = [enumColArray nextObject]) {

		cols = [record componentsSeparatedByString:@","];
		title = [cols objectAtIndex:0];
		identifier = [cols objectAtIndex:1];

		if([tbvSearchlist isShowColumn:identifier] == YES){
			state = 1;
		}else{
			state = 0;
		}

		senderString = [NSString stringWithFormat: @"%@,%d",identifier,state];

		menuItem = [[[NSMenuItem alloc] initWithTitle:title action:@selector(changeColumnState:) keyEquivalent:@""] autorelease];
		[menuItem setTarget:tbvSearchlist];
		[menuItem setRepresentedObject:senderString];
		[menuItem setState:state];
         
        [self addItem:menuItem];
    }

}
//------------------------------------
// menuItems
//------------------------------------
-(NSArray*)menuItems
{
	// must show at least 1 binded column
	return 	[[NSArray alloc] initWithObjects: 
				@"No,index",
				@"Image,image",
//				@"Description,description",
				@"Time,length",
				@"Views,viewCount",
				@"Res,resCount",
				@"Mylist,mylistCount",
				@"Date,postedDate",
//				@"VideoID,videoId",
				nil
			];
}
//------------------------------------
// menuNeedsUpdate
//------------------------------------
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self setMenuItem];
}

@end
