#import <Cocoa/Cocoa.h>
#import "ConnectionStatus.h"

@interface ConnectionDataItem : NSObject
{
	NSURLConnection *connection_;
	NSError *error_;
	id notifyTarget_;

	NSString *urlString_;
	NSMutableData *data_;
	NSDictionary *params_;
	int status_;

}
- (id)initWithURL:(NSString*)urlString
			userInfo:(NSDictionary*)userInfo
			notifyTarget:(id)notifyTarget
			params:(NSDictionary*)params;
- (BOOL)getDataWithURL:(NSString*)urlString
				userInfo:(NSDictionary*)userInfo
				notifyTarget:(id)notifyTarget;

- (BOOL)createConnection:(NSString*)urlString userInfo:(NSDictionary*)userInfo;
- (void)notifyConnectionDataItemStatus:(ConnectionDataItem*)item;
- (void)notifyConnectionDataItemDidLoad:(ConnectionDataItem*)item;
- (void)cancelConnection;
- (void)removeItemObserver:(ConnectionDataItem*)item;

- (void)setConnection:(NSURLConnection*)connection;
- (NSURLConnection*)connection;
- (void)setError:(NSError*)error;
- (NSError*)error;
- (void)setStatus:(int)status;
- (int)status;

- (void)setParams:(NSDictionary*)params;
- (NSDictionary*)params;

- (void)setUrlString:(NSString*)urlString;
- (NSString*)urlString;
- (NSData*)data;
@end
