#import "ContentDescTextView.h"
#import "ConvertExtension.h"

@implementation ContentDescTextView
//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

//	[super setDelegate:self];

}
//------------------------------------
// selectedString
//------------------------------------
- (NSString*)selectedString
{
	NSString *string = @"";
	NSRange selectedRange = [self selectedRange];

	if (selectedRange.length > 0) {

/*
		if (selectedRange.length == 0) {
			selectedRange.location--;
			selectedRange = [self selectionRangeForProposedRange:selectedRange granularity:NSSelectByWord];
		}
*/
		string = [self getStringWithRange:selectedRange];
	}

	return string;
}
//------------------------------------
// getBeforeString
//------------------------------------
- (NSString*)getBeforeString:(int)location length:(int)length
{
	NSString *string = @"";
	if(location < length){
		length = location;
	}
	if(length > 0){
		NSRange targetRange = NSMakeRange(location - length, length);
		string = [self getStringWithRange:targetRange];
	}
//	NSLog(@"string=%@", string);
	return string;
}
//------------------------------------
// getStringWithRange
//------------------------------------
- (NSString*)getStringWithRange:(NSRange)range
{
	NSString *string = @"";
	if (range.length > 0) {
		string = [[[self textStorage] mutableString] substringWithRange:range];
		// replace special character
		string = [self tranceteSpecialCharacter:string];
		// trim " "
		string = [string stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
	}
	return string;
}
//------------------------------------
// selectedStringIsNull
//------------------------------------
- (BOOL)selectedStringIsNull
{
	if([[self selectedString] isEqualToString:@""]){
		return YES;
	}else{
		return NO;
	}
}
//------------------------------------
// selectedStringIsAlphabet
//------------------------------------
- (BOOL)selectedStringIsAlphabet
{
	return [self checkIsAlphabetString:[self selectedString]];
}

//------------------------------------
// selectedStringIsNumber
//------------------------------------
- (BOOL)selectedStringIsNumber
{
	return [self checkIsNumberString:[self selectedString]];
}
//------------------------------------
// selectedStringIsAlphabetOrNumber
//------------------------------------
- (BOOL)selectedStringIsAlphabetOrNumber
{
	return [self checkIsAlphabetOrNumberString:[self selectedString]];
}
//------------------------------------
// selectedStringIsAlphabetAndNumberOrNumber
//------------------------------------
- (BOOL)selectedStringIsAlphabetAndNumberOrNumber
{
	BOOL ret = NO;

	// alphabet or number
	if([self selectedStringIsAlphabetOrNumber] == YES){
		if([self selectedStringIsAlphabet] == YES){
			// only alphabet
		}else{
			// (alphabet + number) or number
			ret = YES;
		}
	}

	return ret;
}
//------------------------------------
// selectedStringIsMylistNo
//------------------------------------
- (BOOL)selectedStringIsMylistNo
{
	// mylist/xxxxx
	NSRange selectedRange = [self selectedRange];
	if(selectedRange.length > 0){
		if([[self getBeforeString:selectedRange.location length:7] isEqualToString:@"mylist/"]){
			return YES;
		}else{
			return NO;
		}
	}else{
		return NO;
	}
}
//------------------------------------
// selectedStringIsPostUserId
//------------------------------------
- (BOOL)selectedStringIsPostUserId
{
	// mylist/xxxxx
	NSRange selectedRange = [self selectedRange];
	if(selectedRange.length > 0){
		if([[self getBeforeString:selectedRange.location length:5] isEqualToString:@"user/"]){
			return YES;
		}else{
			return NO;
		}
	}else{
		return NO;
	}
}
//------------------------------------
// selectedStringIsURL
//------------------------------------
- (BOOL)selectedStringIsURL
{
	return [self checkIsURLString:[self selectedString]];
}
//------------------------------------
// menuForEvent
//------------------------------------
- (NSMenu*)menuForEvent:(NSEvent *)theEvent
{
	return CMContentDesc;
}
/*
//------------------------------------
// mouseDown
//------------------------------------
- (void)mouseDown:(NSEvent *)theEvent
{	
	BOOL isAction = NO;

	// control click
	if([theEvent modifierFlags] & NSControlKeyMask){
		[self rightMouseDown:theEvent];
		isAction = YES;
	}

	if(isAction == NO){
		[super mouseDown:theEvent];
	}
}
//------------------------------------
// rightMouseDown
//------------------------------------
- (void)rightMouseDown:(NSEvent *)theEvent
{	

	BOOL isAction = NO;

	[NSMenu popUpContextMenu:CMContentDesc withEvent:theEvent forView:self];
	isAction = YES;

	if(isAction == NO){
		[super rightMouseDown:theEvent];
	}

}
*/
@end
