/* ConvertExtension */

#import <Cocoa/Cocoa.h>
#import "SearchTypes.h"
#import "DownloadStatus.h"

@interface NSObject(convertExtension_)

- (NSString*)convertToBaseURL;
- (NSString*)convertToSecureBaseURL;
- (NSString*)convertToSecureLoginURL;
- (NSString*)convertToChannelBaseURL;
- (NSString*)convertToExternalBaseURL;
- (NSString*)convertToDictionaryBaseURL;

- (NSString*)convertToThumbWatchBaseURL;
- (NSString*)convertToNicoPlayerSwfURL;
- (NSString*)convertToExternalNicoPlayerSwfURL;
- (NSString*)convertToExternalThumbWatchSwfURL;
- (NSString*)convertToLoginURL:(NSString*)account password:(NSString*)password;

- (NSString*)convertToSearchKeywordURL:(NSString*)searchString;
- (NSString*)convertToSearchTagURL:(NSString*)searchString;
- (NSString*)convertToRssURL:(NSString*)urlString rssType:(int)rssType;
- (NSString*)convertToSearchURL:(NSString*)urlString;
- (NSString*)convertToCategoryURL:(NSString*)categoryName adult:(BOOL)adult;
- (NSString*)convertToCategoryRankingURL:(NSString*)categoryName target:(NSString*)target period:(NSString*)period withRss:(BOOL)withRss rssType:(int)rssType;
- (NSString*)convertToContentsURL:(NSString*)contentsName withRss:(BOOL)withRss rssType:(int)rssType;
- (NSString*)convertToMylistURL:(NSString*)mylistId withRss:(BOOL)withRss rssType:(int)rssType;
- (NSString*)convertToPostUserURL:(NSString*)postUserId withRss:(BOOL)withRss rssType:(int)rssType;
- (NSString*)convertToChannelURL:(NSString*)channelId withRss:(BOOL)withRss rssType:(int)rssType;
- (NSString*)convertToRelatedVideoURL:(NSString*)videoId;
- (NSString*)convertToRelatedTagURL:(NSString*)searchString;
- (NSString*)convertToDictionaryURL:(NSString*)searchString;

- (NSString*)convertToWatchURL:(NSString*)videoId;
- (NSString*)convertToWatchQPlayerURL:(NSString*)videoId;
- (NSString*)convertToPlayerURL:(NSString*)playerURL videoId:(NSString*)videoId width:(int)width height:(int)height;
- (NSString*)convertToExternalThumbWatchURL:(NSString*)videoId width:(int)width height:(int)height;
- (NSString*)convertToPlayerHTML:(NSString*)string;
- (NSString*)convertToThumbInfoURL:(NSString*)videoId;
- (NSString*)convertToGetFileURL:(NSString*)videoId;
- (NSString*)appendStringToURL:(NSString*)url string:(NSString*)string isAdded:(BOOL*)isAdded;
- (NSString*)appendEcoModeStringToURL:(NSString*)url;
- (NSString*)convertToResultString:(int)startIndex
						lastIndex:(int)lastIndex
						totalResults:(int)totalResults
						totalString:(NSString*)totalString
						showTotal:(int)showTotal;
- (NSString*)convertToMylistHeadString:(NSString*)title author:(NSString*)author;

- (NSString*)decodeToPercentEscapesString:(NSString*)string;
- (NSString*)encodeFromPercentEscapesString:(NSString*)string;
- (NSString*)convertToURIDecodedString:(NSString*)string;
- (NSString*)convertToURIEncodedString:(NSString*)string;
- (NSArray*)percentChars;
- (NSArray*)escapeChars;
//- (NSString*)convertToURIEncodedString:(NSString*)string;

- (NSString*)convertToShiftJISString:(char*)string;

- (NSString*)convertDownloadStatusToString:(int)status;
- (NSImage*)convertDownloadStatusToImage:(int)status;
- (NSImage*)convertDownloadSearchToImage:(BOOL)isExist;

- (NSString*)convertFileSizeToString:(double)fileSize;
- (NSString*)convertTimeToString:(int)timeSec;
- (NSString*)convertToComma:(int)value;
- (NSString*)convertToZeroFormat:(int)value;
- (int)convertStringToIntValue:(NSString*)string;
- (NSString*)replaceCharacter:(NSString*)string str1:(NSString*)str1 str2:(NSString*)str2;
- (NSString*)replaceSizeCharacter:(NSString*)string size1:(int)size1 size2:(int)size2;
- (NSString*)replaceWebCharacters:(NSString*)string;
- (NSString*)replaceDateCharacter:(NSString*)string;
- (NSString*)replaceBreakCharacters:(NSString*)string;
- (NSString*)convertFormatedDateString:(NSString*)string;
- (NSString*)convertCalenderDateString:(NSString*)string;
- (NSString*)tranceteSpecialCharacter:(NSString*)string;

- (NSString*)removeTagCharacters:(NSString*)string;
- (NSArray*)createLineBreakArray:(NSString*)string;

- (NSString*)getRssTypeName:(int)rssType;
- (NSString*)getVideoIdFromURL:(NSString*)string setDefault:(BOOL)setDefault;
- (NSString*)getMylistIdFromURL:(NSString*)string setDefault:(BOOL)setDefault;
- (NSString*)getChannelIdFromURL:(NSString*)string setDefault:(BOOL)setDefault;
- (NSString*)getTargetIdFromURL:(NSString*)string targetString:(NSString*)targetString setDefault:(BOOL)setDefault;
- (NSString*)getLastSeparatedString:(NSString*)str sep:(NSString*)sep;
- (BOOL)checkIsNumberString:(NSString*)string;
- (BOOL)checkIsAlphabetString:(NSString*)string;
- (BOOL)checkIsAlphabetOrNumberString:(NSString*)string;
- (BOOL)checkIsURLString:(NSString*)string;
- (BOOL)checkIsChannelString:(NSString*)string;
- (BOOL)checkIsMylistNoString:(NSString*)string;
- (BOOL)checkIsPostUserIdString:(NSString*)string;
- (BOOL)checkIsExistString:(NSString*)string searchString:(NSString*)searchString;

- (int)calcPageMaxIndex:(int)totalResults maxResults:(int)maxResults;


@end
