/* DownloadItem */

#import <Cocoa/Cocoa.h>
#import "DownloadStatus.h"

@interface DownloadItem : NSObject
{

	NSURLDownload *download_;

	long long totalLength_;
	long long receivedLength_;
	int status_;

	NSString *targetURL_;
	NSString *videoId_;
	NSString *fileName_;
	NSString *filePath_;
	NSString *fileExt_;
	NSString *errorLog_;
	NSImage* iconImage_;
	NSTimer *notifyTimer_;

}
- (id)initWithURLString:(NSString*)urlString
				videoId:(NSString*)videoId
				fileName:(NSString*)fileName;
- (BOOL)startDownload:(NSString*)urlString
				videoId:(NSString*)videoId
				fileName:(NSString*)fileName;
- (NSURLDownload*)createDownload:(NSString*)urlString;

- (void)cancelDownload;

- (void)notifyDownloadItemChange:(DownloadItem*)item;

- (void)setDownload:(NSURLDownload*)download;
- (NSURLDownload*)download;

- (void)setTotalLength:(long long)totalLength;
- (long long)totalLength;
- (void)setReceivedLength:(long long)receivedLength;
- (long long)receivedLength;
- (void)setStatus:(int)status;
- (int)status;

- (void)setTargetURL:(NSString*)targetURL;
- (NSString*)targetURL;
- (void)setVideoId:(NSString*)videoId;
- (NSString*)videoId;

- (void)setFileName:(NSString*)fileName;
- (NSString*)fileName;
- (void)setFilePath:(NSString*)filePath;
- (NSString*)filePath;
- (void)setFileExt:(NSString*)fileExt;
- (NSString*)fileExt;
- (void)setIconImage:(NSImage*)iconImage;
- (NSImage*)iconImage;
- (void)setErrorLog:(NSString*)errorLog;
- (NSString*)errorLog;

- (void)setNotifyTimer:(NSTimer*)notifyTimer;
- (NSTimer*)notifyTimer;

- (void)createNotifyTimer;
- (void)clearNotifyTimer;
- (void)sendNotifyWithTimer:(NSTimer*)aTimer;

@end
