/* FullScreenWindow */

#import <Cocoa/Cocoa.h>
#import "WebPlayerView.h"
#import "WindowInfoStatus.h"
#import "PlayerTypes.h"
#import "NicoVideoAttribures.h"

@interface FullScreenWindow: NSWindow

{
	IBOutlet WebPlayerView *webPlayerView;

	BOOL isFullScreen_;
	NSRect oldRect_;
	int titleBarHeight_;
	BOOL showPlayerController_;
	BOOL showWindowController_;

}
- (IBAction)changeFullScreen:(id)sender;
- (IBAction)changeFullScreenWithHide:(id)sender;
- (IBAction)toggleFullScreen:(id)sender;

- (void)setFullScreen:(BOOL)isFullScreen animate:(BOOL)animate;
- (void)postWindowFullScreenChangedNotification:(BOOL)isFullScreen;

- (void)setIsFullScreen:(BOOL)isFullScreen;
- (BOOL)isFullScreen;

- (void)setShowPlayerController:(BOOL)showPlayerController;
- (BOOL)showPlayerController;

- (void)setShowWindowController:(BOOL)showWindowController;
- (BOOL)showWindowController;

@end


