/* HelperExtension */

#import <Cocoa/Cocoa.h>
#import "AppControl.h"

@interface NSObject(helperExtension_)

- (void)openVideoWatchURL:(NSString*)videoId;
- (void)openDictionaryURL:(NSString*)string;
- (BOOL)openURLWithBrowser:(NSString*)url;
- (BOOL)openLoginURLWithBrowser;
- (void)openLoginURLWithPlayer;

- (void)copyStringToPasteboard:(NSString*)string;

- (NSData*)getHTMLData:(NSString*)urlString referer:(NSString*)referer error:(NSError**)error;
- (NSString*)getVideoFileURL:(NSString*)videoId message:(NSString**)message;
- (NSString*)getVideoFileURLFromHTML:(NSString*)html;
- (NSString*)encodeHTMLFromData:(NSData*)data;

- (void)getVideoCountStatusString:(NSString*)string
				viewCountStr:(NSString**)viewCountStr
				resCountStr:(NSString**)resCountStr
				mylistCountStr:(NSString**)mylistCountStr
				beginString:(NSString*)beginString
				endString:(NSString*)endString;
- (void)getTagCountStatusString:(NSString*)string
				countStr:(NSString**)countStr
				beginString:(NSString*)beginString
				endString:(NSString*)endString;
- (void)getCategoryRankingPageString:(NSString*)string
				pageStartStr:(NSString**)pageStartStr
				pageEndStr:(NSString**)pageEndStr
				beginString:(NSString*)beginString
				endString:(NSString*)endString;
- (NSDictionary*)getKeyAndValueString:(NSString*)string
				beginString:(NSString*)beginString
				endString:(NSString*)endString;

- (NSString*)getEnclosedString:(NSString*)string
						beginString:(NSString*)beginString
						endString:(NSString*)endString
						withEndSet:(BOOL)withEndSet;
- (NSStringEncoding)getStringEncoding:(NSData*)textData;
- (NSXMLNode*)getChildNode:(NSXMLNode*)node name:(NSString*)name;
- (NSArray*)getChildNodes:(NSXMLNode*)node;

- (BOOL)checkIsWatchURL:(NSString*)urlString;
- (BOOL)checkIsMylistURL:(NSString*)urlString;
- (BOOL)checkIsChannelURL:(NSString*)urlString;
- (BOOL)checkIsTargetURL:(NSString*)urlString targetString:(NSString*)targetString;
- (BOOL)checkIsPreviewVideoId:(NSString*)videoId;

- (BOOL)checkAccessErrorStatus:(NSString*)headHTML bodyHTML:(NSString*)bodyHTML;
- (void)checkAccessErrorHTML:(NSString*)html isBusy:(BOOL*)isBusy
											isDenied:(BOOL*)isDenied
											isNotLogin:(BOOL*)isNotLogin;
- (BOOL)checkNotFoundHTML:(NSString*)html;

- (BOOL)checkEnterAdultCategory;
- (BOOL)checkUserSession;

@end
