#import "ImageItem.h"

@implementation ImageItem
//------------------------------------
// init
//------------------------------------
- (id)initWithImageURL:(NSString*)urlString notifType:(int)notifType
{
    if (self = [super init])
	{
//		image_ = nil;
		[self setImage:[NSImage imageNamed:@"image_loading"]];	
//		[self setImage:nil];	
		[self setUrlString:urlString];	
		itemStatus_ = IMAGE_ITEM_INIT;
		notifType_ = notifType;
		if([self createConnection:urlString] == NO){
			return nil;
		}
    }
    return self;
}

//------------------------------------
// createConnection
//------------------------------------
- (BOOL)createConnection:(NSString*)urlString
{

//	NSLog(@"urlString=%@", urlString);

	// get image
	NSURL *url = [NSURL URLWithString:urlString];

	NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url
															cachePolicy:NSURLRequestUseProtocolCachePolicy
															timeoutInterval:10
									];

	[request setHTTPMethod:@"GET"];

//	[[[NSURLConnection alloc] initWithRequest:request delegate:self] autorelease];
//	[[NSURLConnection alloc] initWithRequest:request delegate:self];
	[self setConnection:[[[NSURLConnection alloc] initWithRequest:request delegate:self] autorelease]];

	if([self connection] != nil){
		return YES;
	}else{
		return NO;
	}

}
//------------------------------------
// didReceiveResponse
//------------------------------------
- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
//	[self setImage:[NSImage imageNamed:@"image_loading"]];	
//	[self notifyImageItemDidLoad:self];
}
//------------------------------------
// didReceiveData
//------------------------------------
- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
	if(!imageData_) imageData_ = [[NSMutableData data] retain];
	[imageData_ appendData:data];
}
//------------------------------------
// didFailWithError
//------------------------------------
- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
	itemStatus_ = IMAGE_ITEM_FAILED;
	[self setImage:[NSImage imageNamed:@"image_failed"]];	
	[self notifyImageItemDidLoad:self];
}
//------------------------------------
// connectionDidFinishLoading
//------------------------------------
- (void)connectionDidFinishLoading:(NSURLConnection*)connection
{
	itemStatus_ = IMAGE_ITEM_SUCCESS;
	[self setImage:[[[NSImage alloc] initWithData:imageData_] autorelease]];	
	[self notifyImageItemDidLoad:self];
}
//------------------------------------
// notifyDownloadItemChange
//------------------------------------
- (void)notifyImageItemDidLoad:(ImageItem*)item
{
//	NSLog(@"notifyDownloadItemChange");
	NSNotificationCenter * nc = [NSNotificationCenter defaultCenter];
//	[nc postNotificationName:@"ImageItemDidLoadNotification" object:item];
	if(notifType_ == IMAGE_ITEM_NOTIF_SEARCH){
		[nc postNotificationName:IMAGE_ITEM_NOTIF_NAME_SEARCH object:item];
	}
	else if(notifType_ == IMAGE_ITEM_NOTIF_RELATED){
		[nc postNotificationName:IMAGE_ITEM_NOTIF_NAME_RELATED object:item];
	}
	else if(notifType_ == IMAGE_ITEM_NOTIF_ITEM){
		[nc postNotificationName:IMAGE_ITEM_NOTIF_NAME_ITEM object:item];
	}
}
//------------------------------------
// cancelConnection
//------------------------------------
- (void)cancelConnection
{
	if(connection_ != nil){
		[connection_ cancel];
	}
}

//------------------------------------
// connection
//------------------------------------
- (void)setConnection:(NSURLConnection*)connection
{
	[connection retain];
	[connection_ release];
	connection_ = connection;
}
- (NSURLConnection*)connection
{
	return connection_;
}

//------------------------------------
// urlString
//------------------------------------
- (void)setUrlString:(NSString*)urlString
{
	[urlString retain];
	[urlString_ release];
	urlString_ = urlString;
}
- (NSString*)urlString
{
	return urlString_;
}

//------------------------------------
// image
//------------------------------------
- (void)setImage:(NSImage*)image
{
	[image retain];
	[image_ release];
	image_ = image;
}
- (NSImage*)image
{
	return image_;
}
//------------------------------------
// itemStatus
//------------------------------------
- (int)itemStatus;
{
	return itemStatus_;
}

//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
//	NSLog(@"dealloc=%@", urlString_);
	[urlString_ release];
	[imageData_ release];
	[image_ release];
	[connection_ release];
    [super dealloc];
}

@end
