#import "LaunchServicesManager.h"
#import "ViewMainSearch.h"
#import "ViewPlayer.h"
#import "ConvertExtension.h"
#import "HelperExtension.h"

@implementation LaunchServicesManager
//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{
	isSearch_ = NO;
}
//=======================================================================
// methods
//=======================================================================
//------------------------------------
// openWithURL
//------------------------------------
- (void)openWithURL:(NSPasteboard*)pboard userData:(NSString*)data error:(NSString**)error
{

	NSArray *types = [pboard types]; 

	if(![types containsObject:NSStringPboardType]) {
		*error = @"Can not open URL.";
		return;
	}

	NSString *urlString = [pboard stringForType:NSStringPboardType];

	if(!urlString) {
		*error = @"Can not open URL.";
		return;
	}

	[self openWithURLString:urlString];

}
//------------------------------------
// handleGetURLEvent
//------------------------------------
- (void)handleGetURLEvent:(NSAppleEventDescriptor *)event withReplyEvent:(NSAppleEventDescriptor *)replyEvent
{
//	NSString *urlString = [[event descriptorForKeyword:keyDirectObject] stringValue];
	NSString *urlString = [[event paramDescriptorForKeyword:keyDirectObject] stringValue];
	[self openWithURLString:urlString];
//	NSLog(@"urlString=%@", urlString);

}
//------------------------------------
// openWithURLString
//------------------------------------
- (void)openWithURLString:(NSString*)urlString
{

	// check url
	BOOL isMylist = [self checkIsMylistURL:urlString];
	BOOL isChannel = [self checkIsChannelURL:urlString];
//	NSLog(@"isMylist=%d", isMylist);

	// mylist
	if(isMylist == YES){
		NSString *mylistId = [self getMylistIdFromURL:urlString setDefault:YES];
		isSearch_ = YES;
		[viewMainSearch openSearchWithMylist:mylistId];
	}
	// channel
	else if(isChannel == YES){
		NSString *channelId = [self getChannelIdFromURL:urlString setDefault:YES];
		isSearch_ = YES;
		[viewMainSearch openSearchWithChannel:channelId];
	}
	// video / other
	else{
		// open player
		if([viewPlayer setPlayerViewWithURL:urlString] == YES){
			[viewPlayer openPlayerWindow:nil];
		}
	}
}
//------------------------------------
// isSearch
//------------------------------------
- (BOOL)isSearch
{
	return isSearch_;
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{	
    [super dealloc];
}

@end
