//
//  MacNicoTunes_AppDelegate.m
//  MacNicoTunes
//
//  Created by MacNicoTunes on 08/09/13.
//  Copyright MacNicoTunes 2008 . All rights reserved.
//

#import "MacNicoTunes_AppDelegate.h"
#import "LaunchServicesManager.h"
#import "DownloadManager.h"
#import "DialogExtension.h"

@implementation MacNicoTunes_AppDelegate

//------------------------------------
// initialize
//------------------------------------
+ (void)initialize {

    [self setupDefaults];

	// register types for service menu
	[NSApp registerServicesMenuSendTypes:[NSArray arrayWithObjects:NSStringPboardType, nil]
								returnTypes:[NSArray arrayWithObjects:NSStringPboardType, nil]
	];

}
//------------------------------------
// setupDefaults
//------------------------------------
+ (void)setupDefaults {

	NSDictionary *defaults = [NSDictionary dictionaryWithObjectsAndKeys:
								@"http://www.nicovideo.jp", @"optNicoVideoBaseURL",	// url for nicovideo
								@"https://secure.nicovideo.jp", @"optNicoVideoSecureBaseURL",	// url for secure
								@"http://ch.nicovideo.jp", @"optNicoVideoChannelBaseURL",	// url for channel
								@"http://ext.nicovideo.jp", @"optNicoVideoExternalBaseURL",	// url for thumbwatch
								@"http://dic.nicovideo.jp", @"optNicoVideoDictionaryBaseURL",	// url for dictionary
								@"", @"optUserAccount",
								@"", @"optUserPassword",
								[NSNumber numberWithInt:0], @"optPlayerType",	//  0:nicoplayer 1:external 2:nicovideo
								[NSNumber numberWithBool:YES], @"optAutoPlay",
								[NSNumber numberWithBool:NO], @"optPlayEcoMode",
								[NSNumber numberWithBool:YES], @"optNicoPlayerAutoMaximize",
								[NSNumber numberWithBool:YES], @"optNicoPlayerShowController",
								[NSNumber numberWithBool:NO], @"optNicoPlayerShowInputArea",
								[NSNumber numberWithBool:YES], @"optNicoPlayerLiveResize",
								[NSNumber numberWithBool:NO], @"optNicoPlayerNoBanner",
								[NSNumber numberWithBool:NO], @"optNicoPlayerNoMarquee",
								[NSNumber numberWithBool:NO], @"optNicoPlayerNoNicowari",
								[NSNumber numberWithBool:NO], @"optNicoPlayerDebugMode",
								[NSNumber numberWithInt:0], @"optSearchTypeWithNumber",	//  0:keyword 1:mylist 2:postuser
//								[NSNumber numberWithBool:NO], @"optSearchWithMylist",	// not used
//								[NSNumber numberWithBool:NO], @"optSearchWithPostUser",	// not used
								[NSNumber numberWithBool:NO], @"optSearchWithChannel",
								@"", @"optExtPlayerURL",	// url for external player
								@"sort=f&order=d", @"optSearchOrderString",
								@"sort=f&order=d", @"optSearchTagOrderString",
								@"sort=f", @"optPostUserOrderStringMain",
								@"sort=f", @"optPostUserOrderStringRelated",
								@"at_d", @"optMylistOrderString",
								@"at_d", @"optPlaylistOrderString",
								[NSNumber numberWithInt:0], @"optSearchKeywordType",	// 0:keyword 1:tag
								@"sort=p", @"optSearchRelatedOrderString",
								[NSNumber numberWithInt:0], @"optSearchRelatedOrderType",	// 0:dsc 1:asc
								@"view", @"optRankingTargetString",
								@"daily", @"optRankingPeriodString",
								[NSNumber numberWithBool:NO], @"optAdultContent",
								[NSNumber numberWithBool:YES], @"optRankingEnabled",		// not used
								[NSNumber numberWithBool:YES], @"optFrameAnimate",
								[NSNumber numberWithBool:NO], @"optVideoContentAutoClose",								
								[NSNumber numberWithInt:32], @"optMaxResults",
//								[NSNumber numberWithInt:15], @"optMaxResultsRelated",		// not used
								[NSNumber numberWithInt:0], @"optTabViewSearchIndex",								
								[NSNumber numberWithInt:10], @"optRequestTimeOut",
								[NSNumber numberWithInt:100], @"optMaxCountPlayHistory",
								[NSNumber numberWithFloat:12.0], @"optFontSizeList",
								[NSNumber numberWithFloat:64.0], @"optSearchRowHeight",
								[NSNumber numberWithFloat:64.0], @"optRelatedRowHeight",
								[NSNumber numberWithFloat:5.0], @"optSearchMatrixCellScale",
								[NSNumber numberWithFloat:0.05], @"optPreviewMovieVolume",
								[NSNumber numberWithBool:YES], @"optPreviewMoviePlay",
								[NSNumber numberWithInt:1], @"optPreviewActionType",		// 0:none 1:stop 2:close
								[NSNumber numberWithBool:YES], @"optDisplayMenuIcon",
								[NSNumber numberWithInt:0], @"optImageBGType",		// 0:none 1:square 2:shadow
								[@"~/Desktop" stringByExpandingTildeInPath], @"optDownloadFolderPath",
								[NSNumber numberWithInt:0], @"optWindowThemeNo",
								nil
							];

	[[NSUserDefaults standardUserDefaults] registerDefaults:defaults];
}
//------------------------------------
// applicationWillFinishLaunching
//------------------------------------
- (void)applicationWillFinishLaunching:(NSNotification *)aNotification
{
	// for apple event
	NSAppleEventManager *appleEventManager = [NSAppleEventManager sharedAppleEventManager];
//	[appleEventManager setEventHandler:launchServicesManager andSelector:@selector(handleGetURLEvent:withReplyEvent:) forEventClass:kInternetEventClass andEventID:kAEGetURL];
	[appleEventManager setEventHandler:launchServicesManager andSelector:@selector(handleGetURLEvent:withReplyEvent:) forEventClass:'GURL' andEventID:'GURL'];
}
//------------------------------------
// applicationDidFinishLaunching
//------------------------------------
- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{

	// for service menu
    [NSApp setServicesProvider:launchServicesManager];

	// for apple event
//	NSAppleEventManager *appleEventManager = [NSAppleEventManager sharedAppleEventManager];
//	[appleEventManager setEventHandler:launchServicesManager andSelector:@selector(handleGetURLEvent:withReplyEvent:) forEventClass:kInternetEventClass andEventID:kAEGetURL];

/*
	// open from arguments
	NSArray *args = [[NSProcessInfo processInfo] arguments]; 
//	NSLog(@"args=%@", [args description]);
	if([args count] > 1){
		[launchServicesManager openWithURLString:[args objectAtIndex:1]];
	}
*/

}
//------------------------------------
// validRequestorForSendType
//------------------------------------
- (id)validRequestorForSendType:(NSString *)sendType
					returnType:(NSString *)returnType
{
	// for other apps service
	if(sendType && [sendType isEqualToString:NSStringPboardType]){
		return self;
	}
/*
	if(!sendType || [sendType isEqualToString:NSStringPboardType]) {
		return self;
	}
*/
	// no other apps service
	return nil;
}
/*
//------------------------------------
// writeSelectionToPasteboard
//------------------------------------
- (BOOL)writeSelectionToPasteboard:(NSPasteboard *)pboard types:(NSArray *)types
{
 
    if ([types containsObject:NSStringPboardType] == NO) {
        return NO;
    }
	return YES;
}
*/
//------------------------------------
// readSelectionFromPasteboard
//------------------------------------
- (BOOL)readSelectionFromPasteboard:(NSPasteboard *)pboard
{
	return YES;
}

/**
    Returns the support folder for the application, used to store the Core Data
    store file.  This code uses a folder named "MacNicoTunes" for
    the content, either in the NSApplicationSupportDirectory location or (if the
    former cannot be found), the system's temporary directory.
 */

- (NSString *)applicationSupportFolder {

    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSApplicationSupportDirectory, NSUserDomainMask, YES);
    NSString *basePath = ([paths count] > 0) ? [paths objectAtIndex:0] : NSTemporaryDirectory();
    return [basePath stringByAppendingPathComponent:@"MacNicoTunes"];
}


/**
    Creates, retains, and returns the managed object model for the application 
    by merging all of the models found in the application bundle and all of the 
    framework bundles.
 */
 
- (NSManagedObjectModel *)managedObjectModel {

    if (managedObjectModel != nil) {
        return managedObjectModel;
    }
	
    NSMutableSet *allBundles = [[NSMutableSet alloc] init];
    [allBundles addObject: [NSBundle mainBundle]];
    [allBundles addObjectsFromArray: [NSBundle allFrameworks]];
    
    managedObjectModel = [[NSManagedObjectModel mergedModelFromBundles: [allBundles allObjects]] retain];
    [allBundles release];
    
    return managedObjectModel;
}


/**
    Returns the persistent store coordinator for the application.  This 
    implementation will create and return a coordinator, having added the 
    store for the application to it.  (The folder for the store is created, 
    if necessary.)
 */

- (NSPersistentStoreCoordinator *) persistentStoreCoordinator {

    if (persistentStoreCoordinator != nil) {
        return persistentStoreCoordinator;
    }

    NSFileManager *fileManager;
    NSString *applicationSupportFolder = nil;
    NSURL *url;
    NSError *error;
    
    fileManager = [NSFileManager defaultManager];
    applicationSupportFolder = [self applicationSupportFolder];
    if ( ![fileManager fileExistsAtPath:applicationSupportFolder isDirectory:NULL] ) {
        [fileManager createDirectoryAtPath:applicationSupportFolder attributes:nil];
    }
    
    url = [NSURL fileURLWithPath: [applicationSupportFolder stringByAppendingPathComponent: @"MacNicoTunes.xml"]];
    persistentStoreCoordinator = [[NSPersistentStoreCoordinator alloc] initWithManagedObjectModel: [self managedObjectModel]];
    if (![persistentStoreCoordinator addPersistentStoreWithType:NSXMLStoreType configuration:nil URL:url options:nil error:&error]){
        [[NSApplication sharedApplication] presentError:error];
    }    

    return persistentStoreCoordinator;
}


/**
    Returns the managed object context for the application (which is already
    bound to the persistent store coordinator for the application.) 
 */
 
- (NSManagedObjectContext *) managedObjectContext {

    if (managedObjectContext != nil) {
        return managedObjectContext;
    }

    NSPersistentStoreCoordinator *coordinator = [self persistentStoreCoordinator];
    if (coordinator != nil) {
        managedObjectContext = [[NSManagedObjectContext alloc] init];
        [managedObjectContext setPersistentStoreCoordinator: coordinator];
    }
    
    return managedObjectContext;
}


/**
    Returns the NSUndoManager for the application.  In this case, the manager
    returned is that of the managed object context for the application.
 */
 
- (NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)window {
    return [[self managedObjectContext] undoManager];
}


/**
    Performs the save action for the application, which is to send the save:
    message to the application's managed object context.  Any encountered errors
    are presented to the user.
 */
 
- (IBAction) saveAction:(id)sender {

    NSError *error = nil;
    if (![[self managedObjectContext] save:&error]) {
        [[NSApplication sharedApplication] presentError:error];
    }
}


/**
    Implementation of the applicationShouldTerminate: method, used here to
    handle the saving of changes in the application managed object context
    before the application terminates.
 */

- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender {

    NSError *error;
    int reply = NSTerminateNow;

	// confirm cancel download
	if([downloadManager anyItemIsDownloading] == YES){
		int result = [self displayMessage:@"alert"
						messageText:@"Downloading is not compeleted."
						infoText:@"Quit application?"
						btnList:@"Cancel, Quit"
				];

		// cancel quit
		if(result == NSAlertFirstButtonReturn){
			return NSTerminateCancel;
		}
		// cancel download
		else{
			[downloadManager cancelAllDownloadItem:nil];
		}

	}

	// store last state
	[olvPlaylist storeLastState];

    if (managedObjectContext != nil) {
        if ([managedObjectContext commitEditing]) {
            if ([managedObjectContext hasChanges] && ![managedObjectContext save:&error]) {
				
                // This error handling simply presents error information in a panel with an 
                // "Ok" button, which does not include any attempt at error recovery (meaning, 
                // attempting to fix the error.)  As a result, this implementation will 
                // present the information to the user and then follow up with a panel asking 
                // if the user wishes to "Quit Anyway", without saving the changes.

                // Typically, this process should be altered to include application-specific 
                // recovery steps.  

                BOOL errorResult = [[NSApplication sharedApplication] presentError:error];
				
                if (errorResult == YES) {
                    reply = NSTerminateCancel;
                } 

                else {
					
                    int alertReturn = NSRunAlertPanel(nil, @"Could not save changes while quitting. Quit anyway?" , @"Quit anyway", @"Cancel", nil);
                    if (alertReturn == NSAlertAlternateReturn) {
                        reply = NSTerminateCancel;	
                    }
                }
            }
        } 
        
        else {
            reply = NSTerminateCancel;
        }
    }
    
    return reply;
}

/**
    Implementation of dealloc, to release the retained variables.
 */
- (void) dealloc {

    [managedObjectContext release], managedObjectContext = nil;
    [persistentStoreCoordinator release], persistentStoreCoordinator = nil;
    [managedObjectModel release], managedObjectModel = nil;
    [super dealloc];
}


@end
