#import "MenuItemCategory.h"
#import "ViewPlaylist.h"
#import "NicoVideoExtension.h"

@implementation MenuItemCategory

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	// set menu items
	[self setMenuItems:[self getCategoryMenuItems]];

	// createSubMenu
	subMenu_ = [[[NSMenu alloc] initWithTitle:@"CategoryMenu"] autorelease];
	[self createSubMenu:subMenu_];

	//set delegate menu
	[subMenu_ setDelegate: self ];
}
//------------------------------------
// addCategorylist
//------------------------------------
- (IBAction)addCategorylist:(id)sender
{

	[viewPlaylist addCategorylist:sender];

}
//------------------------------------
// createSubMenu
//------------------------------------
- (void)createSubMenu:(NSMenu*)aMenu
{

	int indent;

	NSString *name;
	NSString *type;
	NSString *title;
	int i;
	id record;

	// remove menuItem
	NSEnumerator *enumArray = [[aMenu itemArray] objectEnumerator];
	while (record = [enumArray nextObject]) {
		[aMenu removeItem:record];
	}

	NSArray *menuItems = [self menuItems];
	NSMenuItem *menuItem;

	for(i = 0; i < [menuItems count]; i++){

		record = [menuItems objectAtIndex:i];
		name = [record valueForKey:@"name"];
		type = [record valueForKey:@"type"];

		indent = 0;

		if([type isEqualToString:@"c"]){
			indent = 1;
		}

		// add item separator
		if([name isEqualToString:@"-"]){
			[aMenu addItem:[NSMenuItem separatorItem]];
			continue;
		}

		// set title
		title = [self getCategoryTitle:name];
		// set action
		SEL sel;
		sel = NSSelectorFromString(@"addCategorylist:");

		menuItem = [[[NSMenuItem alloc] initWithTitle:title action:sel keyEquivalent:@""] autorelease];
		[menuItem setTarget:self];
		[menuItem setRepresentedObject:name];
		[menuItem setIndentationLevel:indent];

		// set image
		[menuItem setImage:[NSImage imageNamed:@"icon_category"]];

		[aMenu addItem:menuItem];
	}

	[self setSubmenu:aMenu];
	
	[menuItems release];

}
//------------------------------------
// setMenuItems
//------------------------------------
- (void)setMenuItems:(NSArray*)menuItems
{
	[menuItems retain];
	[menuItems_ release];
	menuItems_ = menuItems;
}
//------------------------------------
// menuItems
//------------------------------------
- (NSArray*)menuItems
{
	return menuItems_;
}

//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[menuItems_ release];
	[subMenu_ release];
    [super dealloc];
}
/*
//------------------------------------
// menuNeedsUpdate
//------------------------------------
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self createSubMenu:menu];
}
*/

@end
