#import "MenuItemContents.h"
#import "ViewPlaylist.h"
#import "NicoVideoExtension.h"

@implementation MenuItemContents

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{
	// createSubMenu
	subMenu_ = [[[NSMenu alloc] initWithTitle:@"ContentsMenu"] autorelease];
	[self createSubMenu:subMenu_];

	//set delegate menu
	[subMenu_ setDelegate: self ];
}
//------------------------------------
// addContentslist
//------------------------------------
- (IBAction)addContentslist:(id)sender
{

	[viewPlaylist addContentslist:sender];

}
//------------------------------------
// createSubMenu
//------------------------------------
- (void)createSubMenu:(NSMenu*)aMenu
{

	NSArray *cols;
	NSString *title;
	int i;
	int contentsType;
	id record;

	// remove menuItem
	NSEnumerator *enumArray = [[aMenu itemArray] objectEnumerator];
	while (record = [enumArray nextObject]) {
		[aMenu removeItem:record];
	}

	NSArray *menuItems = [self menuItems];
	NSMenuItem *menuItem;

	for(i = 0; i < [menuItems count]; i++){

		cols = [[menuItems objectAtIndex:i] componentsSeparatedByString:@","];

		// add item separator
		if([[cols objectAtIndex:0] isEqualToString:@"-"]){
			[aMenu addItem:[NSMenuItem separatorItem]];
			continue;
		}

		contentsType = [[cols objectAtIndex:0] intValue];

		// set title
		title = [self getContentsTitle:contentsType];
		// set action
		SEL sel;
		sel = NSSelectorFromString(@"addContentslist:");

		menuItem = [[[NSMenuItem alloc] initWithTitle:title action:sel keyEquivalent:@""] autorelease];
		[menuItem setTarget:self];
//		[menuItem setRepresentedObject:[NSNumber numberWithInt:[[cols objectAtIndex:1] intValue]]];
		[menuItem setTag:contentsType];

		// set image
		[menuItem setImage:[NSImage imageNamed:@"icon_contents"]];

		[aMenu addItem:menuItem];
	}

	[self setSubmenu:aMenu];
	
	[menuItems release];

}
//------------------------------------
// menuItems
//------------------------------------
- (NSArray*)menuItems
{
	// contentsType
	return [[NSArray alloc] initWithObjects: 
//			@"9,",	// top
			@"0,",	// newarrival
			@"1,",	// recent
			@"2,",	// hotlist
//			@"3,",	// random
  			nil];
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[subMenu_ release];	
    [super dealloc];
}

/*
//------------------------------------
// menuNeedsUpdate
//------------------------------------
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self createSubMenu:menu];
}
*/

@end
