#import "MenuItemShowComment.h"
#import "UserDefaultsExtension.h"

static NSString *defaultKey = @"optNicoPlayerShowInputArea";

@implementation MenuItemShowComment

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{
	[self setMenuState];

	// add observer
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults addObserver:self forKeyPath:defaultKey options:0 context:nil];
}
//------------------------------------
// setMenuState
//------------------------------------
- (void)setMenuState
{

	if([self defaultBoolValue:defaultKey] == YES){
		[self setState:1];
	}else{
		[self setState:0];
	}

}
//------------------------------------
// observeValueForKeyPath
//------------------------------------
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
	if([keyPath isEqualToString:defaultKey]){
		// setMenuState
		[self setMenuState];
	}
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[[NSUserDefaults standardUserDefaults] removeObserver:self forKeyPath:defaultKey];
	[super dealloc];
}

@end
