/* NicoVideoExtension */

#import <Cocoa/Cocoa.h>
#import "PlaylistItemTypes.h"
#import "TimePeriodTypes.h"
#import "SearchTypes.h"
#import "SearchTagTypes.h"

@interface NSObject(nicoVideoExtension_)

- (NSArray*)getCategoryItems;
- (NSArray*)getCategoryMenuItems;
- (NSString*)getCategoryName:(int)itemSubType;
- (NSString*)getCategoryTitle:(NSString*)name;
- (int)getCategoryOrder:(NSString*)name;
- (BOOL)checkCategoryEnable:(NSString*)name message:(NSString**)message;

- (NSString*)getContentsTitle:(int)itemSubType;
- (NSString*)getContentsName:(int)itemSubType;
- (int)getContentsType:(NSString*)name;

- (NSImage*)getVideoTypeIcon:(NSString*)videoType;
- (NSString*)getTimePariodName:(int)timePeriod;
- (NSString*)getTimePariodTitle:(int)timePeriod;
- (NSString*)getTimePeriodTitleFromName:(NSString*)timePeriodName;
- (NSString*)getParseSplitString:(int)splitType;
- (NSString*)getParseBreakString:(int)breakType;

- (int)getMaxResults:(int)searchType subName:(NSString*)subName;
- (int)getMaxResultsRelated:(int)searchType;
- (int)getRankingMaxPageIndex:(NSString*)categoryName rankingTarget:(NSString*)rankingTarget rankingPeriod:(NSString*)rankingPeriod;
- (int)getContentsMaxPageIndex:(NSString*)contentsName;
@end
