#import "NicoVideoExtension.h"
#import "ConvertExtension.h"
#import "UserDefaultsExtension.h"

@implementation NSObject(nicoVideoExtension_)

//------------------------------------
// getCategoryItems
//------------------------------------
- (NSArray*)getCategoryItems
{
	return [[NSArray alloc] initWithObjects: 
			// CATEGORY_GROUP_NAME
			  [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_ALL]
			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_CULTURE2]
			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_ENT2]
			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_LIFE2]
			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_OTHER]
			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_POLITICS]
			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_R18]
			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_TECH]
//			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_CULTURE]
//			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_ENT]
//			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_LIFE]
//			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_POPULAR]
//			, [NSString stringWithFormat:@"%@,g", CATEGORY_NAME_G_TRY]
			// CATEGORY_NAME
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_ANIMAL]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_ANIME]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_ARE]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_COOKING]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_DANCE]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_DIARY]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_DRAW]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_DRIVE]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_ENT]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_GAME]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_HANDCRAFT]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_HISTORY]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_IMAS]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_LECTURE]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_MAKE]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_MUSIC]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_NATURE]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_NICOINDIES]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_OTHER]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_PLAY]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_POLITICS]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_R18]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_RADIO]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_SCIENCE]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_SING]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_SPORT]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_TECH]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_TOHO]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_TRAVEL]
			, [NSString stringWithFormat:@"%@,c", CATEGORY_NAME_VOCALOID]
		  	, nil
  		];

}
//------------------------------------
// getCategoryMenuItems
//------------------------------------
- (NSArray*)getCategoryMenuItems
{

	NSArray *items = [self getCategoryItems];
	NSMutableArray *list = [NSMutableArray array];
	NSArray *cols;
	NSString *name;
	NSString *type;
	int order;
	int i;

	for(i = 0; i < [items count]; i++){
		cols = [[items objectAtIndex:i] componentsSeparatedByString:@","];
		name = [cols objectAtIndex:0];
		type = [cols objectAtIndex:1];
		order = [self getCategoryOrder:name];

		[list addObject:
			[NSMutableDictionary dictionaryWithObjectsAndKeys:
				[NSNumber numberWithInt:order], @"order" ,
				name, @"name" ,
				type, @"type" ,
				nil
			]
		];
	}

	NSSortDescriptor *desc = [[NSSortDescriptor alloc] initWithKey:@"order" ascending:YES];
	NSArray *menuItems = [list sortedArrayUsingDescriptors:[NSArray arrayWithObject:desc]];
	[desc release];

	return menuItems;
}

//------------------------------------
// getCategoryName (for older vaersion)
//------------------------------------
- (NSString*)getCategoryName:(int)itemSubType
{
	NSString *value = @"";

	switch (itemSubType){
		case ITEM_CATEGORY_ALL:
			value = CATEGORY_NAME_ALL;
			break;
		case ITEM_CATEGORY_ANIMAL:
			value = CATEGORY_NAME_ANIMAL;
			break;
		case ITEM_CATEGORY_ANIME:
			value = CATEGORY_NAME_ANIME;
			break;
		case ITEM_CATEGORY_CHAT:
			value = CATEGORY_NAME_CHAT;
			break;
		case ITEM_CATEGORY_COMMONS:
			value = CATEGORY_NAME_COMMONS;
			break;
		case ITEM_CATEGORY_COOKING:
			value = CATEGORY_NAME_COOKING;
			break;
		case ITEM_CATEGORY_DANCE:
			value = CATEGORY_NAME_DANCE;
			break;
		case ITEM_CATEGORY_DIARY:
			value = CATEGORY_NAME_DIARY;
			break;
		case ITEM_CATEGORY_ENT:
			value = CATEGORY_NAME_ENT;
			break;
		case ITEM_CATEGORY_GAME:
			value = CATEGORY_NAME_GAME;
			break;
		case ITEM_CATEGORY_HISTORY:
			value = CATEGORY_NAME_HISTORY;
			break;
		case ITEM_CATEGORY_HITOKOTO:
			value = CATEGORY_NAME_HITOKOTO;
			break;
		case ITEM_CATEGORY_LECTURE:
			value = CATEGORY_NAME_LECTURE;
			break;
		case ITEM_CATEGORY_MUSIC:
			value = CATEGORY_NAME_MUSIC;
			break;
		case ITEM_CATEGORY_NATURE:
			value = CATEGORY_NAME_NATURE;
			break;
		case ITEM_CATEGORY_OFFICIAL:
			value = CATEGORY_NAME_OFFICIAL;
			break;
		case ITEM_CATEGORY_OTHER:
			value = CATEGORY_NAME_OTHER;
			break;
		case ITEM_CATEGORY_OWNER:
			value = CATEGORY_NAME_OWNER;
			break;
		case ITEM_CATEGORY_PLAY:
			value = CATEGORY_NAME_PLAY;
			break;
		case ITEM_CATEGORY_POLITICS:
			value = CATEGORY_NAME_POLITICS;
			break;
		case ITEM_CATEGORY_QUE:
			value = CATEGORY_NAME_QUE;
			break;
		case ITEM_CATEGORY_R18:
			value = CATEGORY_NAME_R18;
			break;
		case ITEM_CATEGORY_RADIO:
			value = CATEGORY_NAME_RADIO;
			break;
		case ITEM_CATEGORY_SCIENCE:
			value = CATEGORY_NAME_SCIENCE;
			break;
		case ITEM_CATEGORY_SING:
			value = CATEGORY_NAME_SING;
			break;
		case ITEM_CATEGORY_SPORT:
			value = CATEGORY_NAME_SPORT;
			break;
		case ITEM_CATEGORY_TEST:
			value = CATEGORY_NAME_TEST;
			break;
	}

	return value;

}
//------------------------------------
// getCategoryTitle
//------------------------------------
- (NSString*)getCategoryTitle:(NSString*)name
{
	char *value = "";

	// GROUP
	if([name isEqualToString:CATEGORY_NAME_ALL]){
		value = CATEGORY_TITLE_ALL;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_CULTURE2]){
		value = CATEGORY_TITLE_G_CULTURE2;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_ENT2]){
		value = CATEGORY_TITLE_G_ENT2;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_LIFE2]){
		value = CATEGORY_TITLE_G_LIFE2;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_POLITICS]){
		value = CATEGORY_TITLE_G_POLITICS;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_R18]){
		value = CATEGORY_TITLE_G_R18;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_TECH]){
		value = CATEGORY_TITLE_G_TECH;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_OTHER]){
		value = CATEGORY_TITLE_G_OTHER;
	}
	// GROUP discontinued
	else if([name isEqualToString:CATEGORY_NAME_G_CULTURE]){
		value = CATEGORY_TITLE_G_CULTURE;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_ENT]){
		value = CATEGORY_TITLE_G_ENT;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_LIFE]){
		value = CATEGORY_TITLE_G_LIFE;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_POPULAR]){
		value = CATEGORY_TITLE_G_POPULAR;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_TRY]){
		value = CATEGORY_TITLE_G_TRY;
	}

	// A
	else if([name isEqualToString:CATEGORY_NAME_ANIMAL]){
		value = CATEGORY_TITLE_ANIMAL;
	}
	else if([name isEqualToString:CATEGORY_NAME_ANIME]){
		value = CATEGORY_TITLE_ANIME;
	}
	else if([name isEqualToString:CATEGORY_NAME_ARE]){
		value = CATEGORY_TITLE_ARE;
	}
	// C
	else if([name isEqualToString:CATEGORY_NAME_COOKING]){
		value = CATEGORY_TITLE_COOKING;
	}
	// D
	else if([name isEqualToString:CATEGORY_NAME_DANCE]){
		value = CATEGORY_TITLE_DANCE;
	}
	else if([name isEqualToString:CATEGORY_NAME_DIARY]){
		value = CATEGORY_TITLE_DIARY;
	}
	else if([name isEqualToString:CATEGORY_NAME_DRAW]){
		value = CATEGORY_TITLE_DRAW;
	}
	else if([name isEqualToString:CATEGORY_NAME_DRIVE]){
		value = CATEGORY_TITLE_DRIVE;
	}
	// E
	else if([name isEqualToString:CATEGORY_NAME_ENT]){
		value = CATEGORY_TITLE_ENT;
	}
	// G
	else if([name isEqualToString:CATEGORY_NAME_GAME]){
		value = CATEGORY_TITLE_GAME;
	}
	// H
	else if([name isEqualToString:CATEGORY_NAME_HANDCRAFT]){
		value = CATEGORY_TITLE_HANDCRAFT;
	}
	else if([name isEqualToString:CATEGORY_NAME_HISTORY]){
		value = CATEGORY_TITLE_HISTORY;
	}
	// I
	else if([name isEqualToString:CATEGORY_NAME_IMAS]){
		value = CATEGORY_TITLE_IMAS;
	}
	// L
	else if([name isEqualToString:CATEGORY_NAME_LECTURE]){
		value = CATEGORY_TITLE_LECTURE;
	}
	// M
	else if([name isEqualToString:CATEGORY_NAME_MAKE]){
		value = CATEGORY_TITLE_MAKE;
	}
	else if([name isEqualToString:CATEGORY_NAME_MUSIC]){
		value = CATEGORY_TITLE_MUSIC;
	}
	else if([name isEqualToString:CATEGORY_NAME_NATURE]){
		value = CATEGORY_TITLE_NATURE;
	}
	// N
	else if([name isEqualToString:CATEGORY_NAME_NICOINDIES]){
		value = CATEGORY_TITLE_NICOINDIES;
	}
	// O
	else if([name isEqualToString:CATEGORY_NAME_OTHER]){
		value = CATEGORY_TITLE_OTHER;
	}
	// P
	else if([name isEqualToString:CATEGORY_NAME_PLAY]){
		value = CATEGORY_TITLE_PLAY;
	}
	else if([name isEqualToString:CATEGORY_NAME_POLITICS]){
		value = CATEGORY_TITLE_POLITICS;
	}
	// R
	else if([name isEqualToString:CATEGORY_NAME_R18]){
		value = CATEGORY_TITLE_R18;
	}
	else if([name isEqualToString:CATEGORY_NAME_RADIO]){
		value = CATEGORY_TITLE_RADIO;
	}
	// S
	else if([name isEqualToString:CATEGORY_NAME_SCIENCE]){
		value = CATEGORY_TITLE_SCIENCE;
	}
	else if([name isEqualToString:CATEGORY_NAME_SING]){
		value = CATEGORY_TITLE_SING;
	}
	else if([name isEqualToString:CATEGORY_NAME_SPORT]){
		value = CATEGORY_TITLE_SPORT;
	}
	// T
	else if([name isEqualToString:CATEGORY_NAME_TECH]){
		value = CATEGORY_TITLE_TECH;
	}
	else if([name isEqualToString:CATEGORY_NAME_TOHO]){
		value = CATEGORY_TITLE_TOHO;
	}
	else if([name isEqualToString:CATEGORY_NAME_TRAVEL]){
		value = CATEGORY_TITLE_TRAVEL;
	}
	// V
	else if([name isEqualToString:CATEGORY_NAME_VOCALOID]){
		value = CATEGORY_TITLE_VOCALOID;
	}

	// use under v2.5.x
	else if([name isEqualToString:CATEGORY_NAME_OWNER]){
		value = CATEGORY_TITLE_OWNER;
	}
	else if([name isEqualToString:CATEGORY_NAME_QUE]){
		value = CATEGORY_TITLE_QUE;
	}
	else if([name isEqualToString:CATEGORY_NAME_CHAT]){
		value = CATEGORY_TITLE_CHAT;
	}
	else if([name isEqualToString:CATEGORY_NAME_TEST]){
		value = CATEGORY_TITLE_TEST;
	}
	else if([name isEqualToString:CATEGORY_NAME_COMMONS]){
		value = CATEGORY_TITLE_COMMONS;
	}
	else if([name isEqualToString:CATEGORY_NAME_HITOKOTO]){
		value = CATEGORY_TITLE_HITOKOTO;
	}
	else if([name isEqualToString:CATEGORY_NAME_OFFICIAL]){
		value = CATEGORY_TITLE_OFFICIAL;
	}

	return [self convertToShiftJISString:value];

}
//------------------------------------
// getCategoryOrder
//------------------------------------
- (int)getCategoryOrder:(NSString*)name
{
	int value = 999;

	// GROUP
	if([name isEqualToString:CATEGORY_NAME_ALL]){
		value = CATEGORY_ORDER_ALL;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_CULTURE2]){
		value = CATEGORY_ORDER_G_CULTURE2;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_ENT2]){
		value = CATEGORY_ORDER_G_ENT2;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_LIFE2]){
		value = CATEGORY_ORDER_G_LIFE2;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_POLITICS]){
		value = CATEGORY_ORDER_G_POLITICS;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_R18]){
		value = CATEGORY_ORDER_G_R18;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_TECH]){
		value = CATEGORY_ORDER_G_TECH;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_OTHER]){
		value = CATEGORY_ORDER_G_OTHER;
	}
	// GROUP discontinued
	else if([name isEqualToString:CATEGORY_NAME_G_CULTURE]){
		value = CATEGORY_ORDER_G_CULTURE;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_ENT]){
		value = CATEGORY_ORDER_G_ENT;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_LIFE]){
		value = CATEGORY_ORDER_G_LIFE;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_POPULAR]){
		value = CATEGORY_ORDER_G_POPULAR;
	}
	else if([name isEqualToString:CATEGORY_NAME_G_TRY]){
		value = CATEGORY_ORDER_G_TRY;
	}

	// A
	else if([name isEqualToString:CATEGORY_NAME_ANIMAL]){
		value = CATEGORY_ORDER_ANIMAL;
	}
	else if([name isEqualToString:CATEGORY_NAME_ANIME]){
		value = CATEGORY_ORDER_ANIME;
	}
	else if([name isEqualToString:CATEGORY_NAME_ARE]){
		value = CATEGORY_ORDER_ARE;
	}
	// C
	else if([name isEqualToString:CATEGORY_NAME_COOKING]){
		value = CATEGORY_ORDER_COOKING;
	}
	// D
	else if([name isEqualToString:CATEGORY_NAME_DANCE]){
		value = CATEGORY_ORDER_DANCE;
	}
	else if([name isEqualToString:CATEGORY_NAME_DIARY]){
		value = CATEGORY_ORDER_DIARY;
	}
	else if([name isEqualToString:CATEGORY_NAME_DRAW]){
		value = CATEGORY_ORDER_DRAW;
	}
	else if([name isEqualToString:CATEGORY_NAME_DRIVE]){
		value = CATEGORY_ORDER_DRIVE;
	}
	// E
	else if([name isEqualToString:CATEGORY_NAME_ENT]){
		value = CATEGORY_ORDER_ENT;
	}
	// G
	else if([name isEqualToString:CATEGORY_NAME_GAME]){
		value = CATEGORY_ORDER_GAME;
	}
	// H
	else if([name isEqualToString:CATEGORY_NAME_HANDCRAFT]){
		value = CATEGORY_ORDER_HANDCRAFT;
	}
	else if([name isEqualToString:CATEGORY_NAME_HISTORY]){
		value = CATEGORY_ORDER_HISTORY;
	}
	// I
	else if([name isEqualToString:CATEGORY_NAME_IMAS]){
		value = CATEGORY_ORDER_IMAS;
	}
	// L
	else if([name isEqualToString:CATEGORY_NAME_LECTURE]){
		value = CATEGORY_ORDER_LECTURE;
	}
	// M
	else if([name isEqualToString:CATEGORY_NAME_MAKE]){
		value = CATEGORY_ORDER_MAKE;
	}
	else if([name isEqualToString:CATEGORY_NAME_MUSIC]){
		value = CATEGORY_ORDER_MUSIC;
	}
	else if([name isEqualToString:CATEGORY_NAME_NATURE]){
		value = CATEGORY_ORDER_NATURE;
	}
	// N
	else if([name isEqualToString:CATEGORY_NAME_NICOINDIES]){
		value = CATEGORY_ORDER_NICOINDIES;
	}
	// O
	else if([name isEqualToString:CATEGORY_NAME_OTHER]){
		value = CATEGORY_ORDER_OTHER;
	}
	// P
	else if([name isEqualToString:CATEGORY_NAME_PLAY]){
		value = CATEGORY_ORDER_PLAY;
	}
	else if([name isEqualToString:CATEGORY_NAME_POLITICS]){
		value = CATEGORY_ORDER_POLITICS;
	}
	// R
	else if([name isEqualToString:CATEGORY_NAME_R18]){
		value = CATEGORY_ORDER_R18;
	}
	else if([name isEqualToString:CATEGORY_NAME_RADIO]){
		value = CATEGORY_ORDER_RADIO;
	}
	// S
	else if([name isEqualToString:CATEGORY_NAME_SCIENCE]){
		value = CATEGORY_ORDER_SCIENCE;
	}
	else if([name isEqualToString:CATEGORY_NAME_SING]){
		value = CATEGORY_ORDER_SING;
	}
	else if([name isEqualToString:CATEGORY_NAME_SPORT]){
		value = CATEGORY_ORDER_SPORT;
	}
	// T
	else if([name isEqualToString:CATEGORY_NAME_TECH]){
		value = CATEGORY_ORDER_TECH;
	}
	else if([name isEqualToString:CATEGORY_NAME_TOHO]){
		value = CATEGORY_ORDER_TOHO;
	}
	else if([name isEqualToString:CATEGORY_NAME_TRAVEL]){
		value = CATEGORY_ORDER_TRAVEL;
	}
	// V
	else if([name isEqualToString:CATEGORY_NAME_VOCALOID]){
		value = CATEGORY_ORDER_VOCALOID;
	}

	return value;

}

//------------------------------------
// checkCategoryEnable
//------------------------------------
- (BOOL)checkCategoryEnable:(NSString*)name message:(NSString**)message
{
	BOOL enable = YES;

	// disabled nico(9) or later
	if(
		[name isEqualToString:CATEGORY_NAME_OWNER] ||
		[name isEqualToString:CATEGORY_NAME_QUE] ||
		[name isEqualToString:CATEGORY_NAME_CHAT] ||
		[name isEqualToString:CATEGORY_NAME_TEST] ||
		[name isEqualToString:CATEGORY_NAME_COMMONS] ||
		[name isEqualToString:CATEGORY_NAME_HITOKOTO] ||
		[name isEqualToString:CATEGORY_NAME_OFFICIAL] ||
		[name isEqualToString:CATEGORY_NAME_FASHION] ||
		[name isEqualToString:CATEGORY_NAME_G_POPULAR] ||
		[name isEqualToString:CATEGORY_NAME_G_TRY]
	){
		*message = [self convertToShiftJISString:"̃JeS[͔p~܂B"];
		enable = NO;
	}

	// disabled nico(zero) or later
	if(
		[name isEqualToString:CATEGORY_NAME_G_CULTURE] ||
		[name isEqualToString:CATEGORY_NAME_G_ENT] ||
		[name isEqualToString:CATEGORY_NAME_G_LIFE]
	){
		*message = [self convertToShiftJISString:"̃JeS[IDύX܂BVo^ĉB"];
		enable = NO;
	}

	return enable;

}

//------------------------------------
// getContentsName
//------------------------------------
- (NSString*)getContentsName:(int)itemSubType
{
	NSString *value = @"";

	switch (itemSubType){
		case ITEM_CONTENTS_NEWARRIVAL:
			value = CONTENTS_NAME_NEWARRIVAL;
			break;
		case ITEM_CONTENTS_RECENT:
			value = CONTENTS_NAME_RECENT;
			break;
		case ITEM_CONTENTS_HOTLIST:
			value = CONTENTS_NAME_HOTLIST;
			break;
//		case ITEM_CONTENTS_RANDOM:
//			value = CONTENTS_NAME_RANDOM;
//			break;
		case ITEM_CONTENTS_TOPPAGE:
			value = CONTENTS_NAME_TOPPAGE;
			break;
	}

	return value;

}
//------------------------------------
// getContentsTitle
//------------------------------------
- (NSString*)getContentsTitle:(int)itemSubType
{
	char *value = "";

	switch (itemSubType){
		case ITEM_CONTENTS_NEWARRIVAL:
			value = CONTENTS_TITLE_NEWARRIVAL;
			break;
		case ITEM_CONTENTS_RECENT:
			value = CONTENTS_TITLE_RECENT;
			break;
		case ITEM_CONTENTS_HOTLIST:
			value = CONTENTS_TITLE_HOTLIST;
			break;
//		case ITEM_CONTENTS_RANDOM:
//			value = CONTENTS_TITLE_RANDOM;
//			break;
		case ITEM_CONTENTS_TOPPAGE:
			value = CONTENTS_TITLE_TOPPAGE;
			break;
	}

	return [self convertToShiftJISString:value];

}
//------------------------------------
// getContentsType
//------------------------------------
- (int)getContentsType:(NSString*)name
{
	int value = 0;

	if([name isEqualToString:CONTENTS_NAME_NEWARRIVAL]){
		value = ITEM_CONTENTS_NEWARRIVAL;
	}
	else if([name isEqualToString:CONTENTS_NAME_RECENT]){
		value = ITEM_CONTENTS_RECENT;
	}
	else if([name isEqualToString:CONTENTS_NAME_HOTLIST]){
		value = ITEM_CONTENTS_HOTLIST;
	}
/*
	else if([name isEqualToString:CONTENTS_NAME_RANDOM]){
		value = ITEM_CONTENTS_RANDOM;
	}
*/
	else if([name isEqualToString:CONTENTS_NAME_TOPPAGE]){
		value = ITEM_CONTENTS_TOPPAGE;
	}

	return value;

}
//------------------------------------
// getVideoTypeIcon
//------------------------------------
- (NSImage*)getVideoTypeIcon:(NSString*)videoType
{
	NSString *imageName = @"icon_video_type_sm";

	if([videoType isEqualToString:@"sm"]){
		imageName = @"icon_video_type_sm";
	}
	else if([videoType isEqualToString:@"nm"]){
		imageName = @"icon_video_type_nm";
	}
	else if([videoType isEqualToString:@"ca"]){
		imageName = @"icon_video_type_ca";
	}

	return [NSImage imageNamed:imageName];

}
//------------------------------------
// getTimePariodName
//------------------------------------
- (NSString*)getTimePariodName:(int)timePeriod
{
	NSString *value = @"";

	switch (timePeriod){
		case TIME_PERIOD_HOURLY:
			value = TIME_PERIOD_NAME_HOURLY;
			break;
		case TIME_PERIOD_DAILY:
			value = TIME_PERIOD_NAME_DAILY;
			break;
		case TIME_PERIOD_WEEKLY:
			value = TIME_PERIOD_NAME_WEEKLY;
			break;
		case TIME_PERIOD_MONTHLY:
			value = TIME_PERIOD_NAME_MONTHLY;
			break;
		case TIME_PERIOD_TOTAL:
			value = TIME_PERIOD_NAME_TOTAL;
			break;
	}

	return value;

}
//------------------------------------
// getTimePariodTitle
//------------------------------------
- (NSString*)getTimePariodTitle:(int)timePeriod
{
	char *value = "";

	switch (timePeriod){
		case TIME_PERIOD_HOURLY:
			value = TIME_PERIOD_TITLE_HOURLY;
			break;
		case TIME_PERIOD_DAILY:
			value = TIME_PERIOD_TITLE_DAILY;
			break;
		case TIME_PERIOD_WEEKLY:
			value = TIME_PERIOD_TITLE_WEEKLY;
			break;
		case TIME_PERIOD_MONTHLY:
			value = TIME_PERIOD_TITLE_MONTHLY;
			break;
		case TIME_PERIOD_TOTAL:
			value = TIME_PERIOD_TITLE_TOTAL;
			break;
	}

	return [self convertToShiftJISString:value];

}
//------------------------------------
// getTimePeriodTitleFromName
//------------------------------------
- (NSString*)getTimePeriodTitleFromName:(NSString*)timePeriodName
{
	char *value = "";

	if([timePeriodName isEqualToString:TIME_PERIOD_NAME_HOURLY]){
		value = TIME_PERIOD_TITLE_HOURLY;
	}
	else if([timePeriodName isEqualToString:TIME_PERIOD_NAME_DAILY]){
		value = TIME_PERIOD_TITLE_DAILY;
	}
	else if([timePeriodName isEqualToString:TIME_PERIOD_NAME_WEEKLY]){
		value = TIME_PERIOD_TITLE_WEEKLY;
	}
	else if([timePeriodName isEqualToString:TIME_PERIOD_NAME_MONTHLY]){
		value = TIME_PERIOD_TITLE_MONTHLY;
	}
	else if([timePeriodName isEqualToString:TIME_PERIOD_NAME_TOTAL]){
		value = TIME_PERIOD_TITLE_TOTAL;
	}

	return [self convertToShiftJISString:value];
}
//------------------------------------
// getParseSplitString
//------------------------------------
- (NSString*)getParseSplitString:(int)splitType
{
	NSString *value = @"";

	switch (splitType){
		case PARSE_SPLIT_NONE:
			value = PARSE_SPLIT_STRING_NONE;
			break;
		case PARSE_SPLIT_LIST:
			value = PARSE_SPLIT_STRING_LIST;
			break;
		case PARSE_SPLIT_PAGEBODY:
			value = PARSE_SPLIT_STRING_PAGEBODY;
			break;
	}

	return value;
}
//------------------------------------
// getParseBreakString
//------------------------------------
- (NSString*)getParseBreakString:(int)breakType
{
	NSString *value = @"";

	switch (breakType){
		case PARSE_BRAKE_NONE:
			value = PARSE_BRAKE_STRING_NONE;
			break;
		case PARSE_BRAKE_TD:
			value = PARSE_BRAKE_STRING_TD;
			break;
		case PARSE_BRAKE_TR:
			value = PARSE_BRAKE_STRING_TR;
			break;
		case PARSE_BRAKE_VIDEO_INFO:
			value = PARSE_BRAKE_STRING_VIDEO_INFO;
			break;
		case PARSE_BRAKE_THUMB_FRM:
			value = PARSE_BRAKE_STRING_THUMB_FRM;
			break;
		case PARSE_BRAKE_THUMB_VINFO:
			value = PARSE_BRAKE_STRING_THUMB_VINFO;
			break;
	}

	return value;
}

//------------------------------------
// getMaxResults
//------------------------------------
- (int)getMaxResults:(int)searchType subName:(NSString*)subName
{
	// default
	int maxResults = [self defaultIntValue:@"optMaxResults"];
	if(maxResults <= 0){
		maxResults = 32;
	}

	switch (searchType){
		case SEARCH_WITH_STRING:
			maxResults = 32;
/*
			// keyword
			if([subName isEqualToString:SEARCH_WITH_STRING_NAME_KEYWORD]){
				maxResults = 32;
			}
			// tag
			else if([subName isEqualToString:SEARCH_WITH_STRING_NAME_TAG]){
				maxResults = 32;
			}
*/
			break;
		case SEARCH_WITH_CATEGORY:
			maxResults = 24;
			break;
		case SEARCH_WITH_RANKING:
			maxResults = 100;
			break;
		case SEARCH_WITH_CONTENTS:
			if([subName isEqualToString:CONTENTS_NAME_HOTLIST]){
				maxResults = 32;
			}else{
				maxResults = 30;
			}
			break;
		case SEARCH_WITH_MYLIST:
			maxResults = 50;
			break;
		case SEARCH_WITH_POST_USER:
			maxResults = 30;
			break;
		case SEARCH_WITH_PLAYLIST:
			maxResults = 50;
			break;
//		case SEARCH_WITH_URL:
//			maxResults = 100;
//			break;
	}

	return maxResults;
}
//------------------------------------
// getMaxResultsRelated
//------------------------------------
- (int)getMaxResultsRelated:(int)searchType
{
	// default
	int maxResults = 30;

	switch (searchType){
		case SEARCH_RELATED_WITH_VIDEO:
			maxResults = 15;
			break;
		case SEARCH_RELATED_WITH_POST_USER:
			maxResults = 30;
			break;
	}

	return maxResults;
}
//------------------------------------
// getRankingMaxPageIndex
//------------------------------------
- (int)getRankingMaxPageIndex:(NSString*)categoryName rankingTarget:(NSString*)rankingTarget rankingPeriod:(NSString*)rankingPeriod
{

//	NSLog(@"categoryName=%@", categoryName);
//	NSLog(@"rankingTarget=%@", rankingTarget);
//	NSLog(@"rankingPeriod=%@", rankingPeriod);

	int pageMaxIndex = 1;

	// all
	if([categoryName isEqualToString:CATEGORY_NAME_ALL]){
		// hourly
		if([rankingPeriod isEqualToString:TIME_PERIOD_NAME_HOURLY]){
			pageMaxIndex = 1;
		}
		// daily
		else if([rankingPeriod isEqualToString:TIME_PERIOD_NAME_DAILY]){
			pageMaxIndex = 3;
		}
		// other
		else{
			pageMaxIndex = 10;
		}
	}
	// other
	else{
		// total
		if([rankingPeriod isEqualToString:TIME_PERIOD_NAME_TOTAL]){
			pageMaxIndex = 3;
		}
		//other
		else{
			pageMaxIndex = 1;
		}
	}

	return pageMaxIndex;

}
//------------------------------------
// getContentsMaxPageIndex
//------------------------------------
- (int)getContentsMaxPageIndex:(NSString*)contentsName
{

	int pageMaxIndex = 1;

	if([contentsName isEqualToString:CONTENTS_NAME_NEWARRIVAL] ||
		[contentsName isEqualToString:CONTENTS_NAME_RECENT]){
		pageMaxIndex = 10;
	}
	// other
	else{
		pageMaxIndex = 1;
	}

	return pageMaxIndex;

}
@end