#import "NotificationExtension.h"

@implementation NSObject(notificationExtension_)

//------------------------------------
// postFrameAnimNotification
//------------------------------------
- (void)postFrameAnimNotification:(BOOL)isStart
{
	NSNotificationCenter * nc = [NSNotificationCenter defaultCenter];
	[nc postNotificationName:FRAME_NOTIF_ANIM_DID_CHANGED object:[NSNumber numberWithBool:isStart]];
}
//------------------------------------
// postPreviewIndexDidChangedNotification
//------------------------------------
- (void)postPreviewIndexDidChangedNotification:(int)index
{
	NSNotificationCenter * nc = [NSNotificationCenter defaultCenter];
	[nc postNotificationName:PREVIEW_NOTIF_INDEX_DID_CHANGED object:[NSNumber numberWithBool:index]];
}
//------------------------------------
// postPreviewSizeDidChangedNotification
//------------------------------------
- (void)postPreviewSizeDidChangedNotification:(BOOL)isVertical isMaximized:(BOOL)isMaximized
{
	NSDictionary *params = [NSDictionary dictionaryWithObjectsAndKeys:
											[NSNumber numberWithBool:isVertical], @"isVertical" ,
											[NSNumber numberWithBool:isMaximized], @"isMaximized" ,
											nil
							];
	NSNotificationCenter * nc = [NSNotificationCenter defaultCenter];
	[nc postNotificationName:PREVIEW_NOTIF_SIZE_DID_CHANGED object:params];
}

@end