#import "TagDescTextCell.h"
#import "UserDefaultsExtension.h"

@implementation TagDescTextCell
//------------------------------------
// init
//------------------------------------
- (id)init
{
    if (self = [super init])
	{
		[self setChangeFontSize:NO];
		[self setFontSize:13];
    }
    return self;
}

//------------------------------------
// drawInteriorWithFrame
//------------------------------------
- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
{

	NSRect insetRect = NSInsetRect(cellFrame,0,0);

	int fontSize = 13;
	if([self changeFontSize] == YES){
		fontSize = [self fontSize];
	}
	if(fontSize < 13){
		fontSize = 13;
	}

	//
	// ParagraphStyle
	//
	NSMutableParagraphStyle *lineStyle = [[[NSMutableParagraphStyle alloc] init] autorelease];
	[lineStyle setLineBreakMode:NSLineBreakByTruncatingTail];

	//
	// color
	//
	NSColor *titleColor = [NSColor blackColor];
//	if(fontSize > 13){
//		titleColor = [NSColor blueColor];
//	}

	//
	// attribute
	//
	// title
	float titleFontSize = fontSize;
	NSMutableDictionary *titleAttr = [[[NSMutableDictionary alloc] initWithObjectsAndKeys:
											 titleColor, NSForegroundColorAttributeName,
											 [NSFont systemFontOfSize:titleFontSize], NSFontAttributeName,
											 lineStyle, NSParagraphStyleAttributeName,
											 nil
										] autorelease];
											
	//
	// title
	//
	NSString *title = [self stringValue];
	NSSize titleSize = [title sizeWithAttributes:titleAttr];

	//
	// rect
	//
//	float vPadding = 5.0;
	float hPadding = 2.0;
	
	NSRect textRect = NSMakeRect(insetRect.origin.x + hPadding,
//								  insetRect.origin.y + (insetRect.size.height - totalHeight) / 2,
								  insetRect.origin.y,
								  insetRect.size.width - hPadding,
//								  totalHeight
								  insetRect.size.height
								);
	
	NSRect titleRect = NSMakeRect(textRect.origin.x, 
//									textRect.origin.y + (textRect.size.height / 2) - titleSize.height - 2,
									textRect.origin.y,
									textRect.size.width,
									titleSize.height
								);

	//
	// highlighted
	//
	if([self isHighlighted]){
		[titleAttr setValue:[NSColor whiteColor] forKey:NSForegroundColorAttributeName];
	}

	//
	// draw text
	//
	[title drawInRect:titleRect withAttributes:titleAttr];

}
//------------------------------------
// changeFontSize
//------------------------------------
- (void)setChangeFontSize:(BOOL)changeFontSize
{
	changeFontSize_ = changeFontSize;
}
- (BOOL)changeFontSize
{
	return changeFontSize_;
}
//------------------------------------
// fontSize
//------------------------------------
- (void)setFontSize:(int)fontSize
{
	fontSize_ = fontSize;
}
- (int)fontSize
{
	return fontSize_;
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[super dealloc];
}
@end
