#import <Cocoa/Cocoa.h>
#import "VideoItemStatus.h"

@interface VideoInfoItem : NSObject
{
	
	NSString *videoId_;
	NSString *title_;
	NSString *description_;
	NSString *errorDescription_;
	NSString *imageURL_;
	NSString *length_;
	NSString *postUserId_;
	NSString *postedDate_;
	NSString *publishedDate_;
	NSString *lastResBody_;
	NSArray *tagList_;
	NSDictionary *params_;

	int viewCount_;
	int resCount_;
	int mylistCount_;
	int notifType_;
	int itemStatus_;
	BOOL hasImage_;

	id target_;

	NSMutableData *xmlData_;
	NSURLConnection *connection_;

}
- (id)initWithVideo:(NSString*)videoId
				title:(NSString*)title
				target:(id)target
				notifType:(int)notifType
				hasImage:(BOOL)hasImage
				params:(NSDictionary*)params;

- (BOOL)createConnection:(NSString*)urlString;

- (int)parseXMLWithString:(NSString*)xml;

- (void)notifyVideoInfoItemDidLoad:(VideoInfoItem*)item;
- (void)cancelConnection;
- (void)removeItemObserver:(VideoInfoItem*)item;

- (void)setConnection:(NSURLConnection*)connection;
- (NSURLConnection*)connection;
- (void)setVideoId:(NSString*)videoId;
- (NSString*)videoId;
- (void)setTitle:(NSString*)title;
- (NSString*)title;
- (void)setDescription:(NSString*)description;
- (NSString*)description;
- (void)setErrorDescription:(NSString*)errorDescription;
- (NSString*)errorDescription;
- (void)setImageURL:(NSString*)imageURL;
- (NSString*)imageURL;
- (void)setLength:(NSString*)length;
- (NSString*)length;
- (void)setPostUserId:(NSString*)postUserId;
- (NSString*)postUserId;
- (void)setPostedDate:(NSString*)postedDate;
- (NSString*)postedDate;
- (void)setPublishedDate:(NSString*)publishedDate;
- (NSString*)publishedDate;
- (void)setLastResBody:(NSString*)lastResBody;
- (NSString*)lastResBody;
- (void)setTagList:(NSArray*)tagList;
- (NSArray*)tagList;
- (void)setParams:(NSDictionary*)params;
- (NSDictionary*)params;

- (int)viewCount;
- (int)resCount;
- (int)mylistCount;
- (int)itemStatus;
- (int)notifType;
- (BOOL)hasImage;

@end
