/* ViewPlayer */

#import <Cocoa/Cocoa.h>
#import "WebPlayerView.h"
#import "FullScreenWindow.h"
#import "NicoVideoAttribures.h"
#import "ImageItem.h"
#import "VideoInfoItem.h"
#import "PlayerTypes.h"
#import "SearchTypes.h"
#import "SearchTagTypes.h"
#import "BindObjectTypes.h"

@interface ViewPlayer : NSObject
{

	IBOutlet id viewRelatedWindow;
	IBOutlet id viewRelatedSearch;
	IBOutlet id viewTagSearch;
	IBOutlet id viewVideoContent;
	IBOutlet id downloadManager;
	IBOutlet id tbArrayController;

	IBOutlet FullScreenWindow *playerWindow;
	IBOutlet WebPlayerView *webPlayerView;
	IBOutlet NSWindow *enterURLWindow;
	IBOutlet NSTextField *txtURL;

	int arrayNo_;
	NSDictionary *params_;

}

- (IBAction)openPlayerWindow:(id)sender;
- (IBAction)orderFrontPlayerWindow:(id)sender;
- (IBAction)changeWindowScale:(id)sender;
- (IBAction)openEnterURLWindow:(id)sender;
- (IBAction)closeEnterURLWindow:(id)sender;
- (IBAction)openPlayerViewWithVideoId:(id)sender;
- (IBAction)openNicoVideoBaseURL:(id)sender;

- (IBAction)downloadItem:(id)sender;
- (IBAction)openVideoPageWithBrowser:(id)sender;
- (IBAction)copyItemToPasteboard:(id)sender;
- (IBAction)showVideoContent:(id)sender;
- (IBAction)addItemToPlaylist:(id)sender;

- (IBAction)searchRelatedVideo:(id)sender;
- (IBAction)searchPostUserVideo:(id)sender;
- (IBAction)searchRelatedTag:(id)sender;

- (void)changePlayerWindowWithScale:(float)scale;
- (void)changePlayerWindowFrame:(NSSize)newSize marginHeight:(float)marginHeight;

- (BOOL)setPlayerView:(NSString*)videoId title:(NSString*)title params:(NSDictionary*)params arrayNo:(int)arrayNo;
- (BOOL)setPlayerInfo:(NSString*)videoId title:(NSString*)title params:(NSDictionary*)params;
- (BOOL)setPlayerViewWithURL:(NSString*)urlString;
- (void)setPlayerViewWithVideoId:(NSString*)videoId arrayNo:(int)arrayNo;
- (void)setPlayerInfoWithVideoId:(NSString*)videoId;
- (void)setPlayerIsPlayed:(NSString*)videoId isPlayed:(BOOL)isPlayed;

- (void)handleItemObjectChange:(NSNotification *)notification;
- (void)handleItemObjectInfo:(NSNotification *)notification;
- (NSDictionary*)createParamsFromVideoInfoItem:(VideoInfoItem*)videoInfoItem;

- (void)openModalSheet:(NSWindow*)childindow parentWindow:(NSWindow*)parentWindow;
- (void)didEndSheet:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;

- (void)setParams:(NSDictionary*)params;
- (NSDictionary*)params;
- (void)setArrayNo:(int)arrayNo;
- (int)arrayNo;

@end
