/* ViewPreviewPlayer */

#import <Cocoa/Cocoa.h>
#import <QTKit/QTKit.h>
#import "PreviewMovieView.h"
#import "ConnectionDataItem.h"
#import "ViewInfoStatus.h"
#import "BindObjectTypes.h"

@interface ViewPreviewPlayer : NSObject
{

	IBOutlet id viewMainSearch;
	IBOutlet id viewPlayer;
	IBOutlet id logStatusController;

	IBOutlet PreviewMovieView *previewMovieView;

//	IBOutlet NSWindow *previewPlayerWindow;
//	IBOutlet NSButton *btnPlay;

	
	int arrayNo_;
	BOOL isContinuePlaying_;

	ConnectionDataItem *connectionDataItem_;
	NSDictionary *params_;

}

//- (IBAction)openPreviewPlayerWindow:(id)sender;
- (IBAction)playItem:(id)sender;
- (IBAction)controlMoviePlay:(id)sender;
- (IBAction)closeMovie:(id)sender;
- (IBAction)maximizePreviewFrame:(id)sender;

- (BOOL)setPreviewView:(NSString*)videoId title:(NSString*)title params:(NSDictionary*)params arrayNo:(int)arrayNo;
- (BOOL)createPreviewMovieView:(NSString*)videoURL params:(NSDictionary*)params arrayNo:(int)arrayNo;
- (BOOL)createPreviewMovie:(NSString*)videoURL message:(NSString**)message;
- (void)getConnectionData:(NSString*)urlString params:(NSDictionary*)params;

- (void)handleDataItemStatus:(NSNotification *)notification;
- (void)handleDataItemDidLoad:(NSNotification *)notification;
- (void)handleMovieLoadStateDidChanged:(NSNotification *)notification;
- (void)handleMovieVolumeDidChanged:(NSNotification *)notification;
- (void)handleMovieRateDidChanged:(NSNotification *)notification;

- (void)setMovie:(QTMovie*)movie;
- (void)setMoviePlay:(BOOL)isPlay;
- (void)setMovieVolume:(float)volume;
- (void)deleteMovie;
- (void)closeMovieView;

- (void)setConnectionDataItem:(ConnectionDataItem*)connectionDataItem;
- (ConnectionDataItem*)connectionDataItem;
- (void)clearConnection;
- (void)setParams:(NSDictionary*)params;
- (NSDictionary*)params;

- (void)setIsContinuePlaying:(BOOL)isContinuePlaying;
- (BOOL)isContinuePlaying;
- (void)setArrayNo:(int)arrayNo;
- (int)arrayNo;

- (BOOL)hasMovie;
- (BOOL)isPlaying;
- (NSNumber*)boolPlaying;
- (BOOL)isMaximizedPreviewFrame;
- (BOOL)hasParams;

@end
