/* ViewRelatedSearch */

#import <Cocoa/Cocoa.h>
#import "SearchTypes.h"
#import "SearchTagTypes.h"
#import "RelatedWindowStatus.h"
#import "ImageItem.h"
#import "VideoInfoItem.h"
#import "ConnectionDataItem.h"
#import "BindObjectTypes.h"
#import "ViewInfoStatus.h"

@interface ViewRelatedSearch : NSObject
{

	IBOutlet id viewRelatedWindow;
	IBOutlet id viewMainSearch;
	IBOutlet id viewTagSearch;
	IBOutlet id viewPlayer;
	IBOutlet id viewPreviewPlayer;
	IBOutlet id viewVideoContent;
	IBOutlet id viewPlaylistSetting;

	IBOutlet id tbArrayController;
	IBOutlet id downloadManager;
	IBOutlet id logStatusController;
	IBOutlet NSArrayController *relatedlistArrayController;

	IBOutlet NSTabView *tabViewRelatedHead;
	IBOutlet NSSearchField *txtSearchField;
	IBOutlet NSTextField *txtSearchResults;
	IBOutlet NSPopUpButton *pbtnSearchOrder;
	IBOutlet NSPopUpButton *pbtnSearchSort;

	IBOutlet NSPopUpButton *pbtnPostUserOrder;
	IBOutlet NSButton *btnAddPostUser;

	IBOutlet NSButton *btnPagePrev;
	IBOutlet NSButton *btnPageNext;
	IBOutlet NSButton *btnPlay;
	IBOutlet NSButton *btnInfo;

	IBOutlet NSButton *btnSearchCancel;

	IBOutlet NSProgressIndicator *indProc;

	ConnectionDataItem *connectionDataItem_;
	NSMutableArray *itemList_;
 
	NSString *urlString_;
	NSString *videoId_;
	NSString *searchTitle_;
	NSString *resultTitle_;
	NSString *postUserId_;

	NSString *logString_;
	
	int startIndex_;
	int lastIndex_;
	int totalResults_;
	int maxResults_;

	int pageIndex_;
	int pageMaxIndex_;

	int searchType_;

}
- (IBAction)openRelatedSearch:(id)sender;
- (IBAction)searchRelatedVideo:(id)sender;
- (IBAction)searchPostUserVideo:(id)sender;
- (IBAction)searchRelatedTag:(id)sender;
- (IBAction)changeSearchPage:(id)sender;
- (IBAction)moveSearchPage:(id)sender;
- (IBAction)reloadSearchPage:(id)sender;
- (IBAction)cancelSearch:(id)sender;

- (IBAction)playItem:(id)sender;
- (IBAction)downloadItem:(id)sender;

- (IBAction)openVideoPageWithBrowser:(id)sender;
- (IBAction)copyItemToPasteboard:(id)sender;
- (IBAction)showItemDescription:(id)sender;
- (IBAction)showVideoContent:(id)sender;
- (IBAction)addItemToPlaylist:(id)sender;
- (IBAction)addPostUser:(id)sender;

- (void)searchPostUser:(NSString*)videoId postUserId:(NSString*)postUserId searchTitle:(NSString*)searchTitle pageIndex:(int)pageIndex searchType:(int)searchType;
- (void)reloadWithPageIndex:(int)pageIndex;
- (void)searchRelatedVideoWithItems:(NSArray*)items;
- (void)searchPostUserWithItems:(NSArray*)items;
- (void)searchWithRelatedVideo:(NSString*)videoId searchTitle:(NSString*)searchTitle pageIndex:(int)pageIndex searchType:(int)searchType;
- (void)searchWithPostUser:(NSString*)postUserId searchTitle:(NSString*)searchTitle pageIndex:(int)pageIndex searchType:(int)searchType;

- (void)parseResultRss:(NSString*)xml params:(NSDictionary*)params;
- (BOOL)parseRelatedXML:(NSString*)xml maxResults:(int)maxResults;
- (BOOL)parseResultXML:(NSString*)xml
			maxResults:(int)maxResults
			searchType:(int)searchType
			parseRssType:(int)parseRssType;

- (void)changeTabViewRelatedHeadIndex;
- (void)changePageButtonEnable;
- (void)changeOrderButtonEnable;

- (void)getVideoInfoItem:(NSString*)videoId params:(NSDictionary*)params;
- (void)handleItemObjectInfo:(NSNotification *)notification;
- (void)handleDataItemStatus:(NSNotification *)notification;
- (void)handleDataItemDidLoad:(NSNotification *)notification;
- (void)clearConnection;

- (void)addItemList:(NSDictionary*)object;
- (void)removeItemList;

- (void)windowWillClose;
- (void)setWindowTitle:(NSString*)searchTitle searchType:(int)searchType;

- (void)setConnectionDataItem:(ConnectionDataItem*)connectionDataItem;
- (ConnectionDataItem*)connectionDataItem;

- (void)setUrlString:(NSString*)urlString;
- (NSString*)urlString;
- (void)setVideoId:(NSString*)videoId;
- (NSString*)videoId;
- (void)setPostUserId:(NSString*)postUserId;
- (NSString*)postUserId;
- (void)setSearchTitle:(NSString*)searchTitle;
- (NSString*)searchTitle;
- (void)setResultTitle:(NSString*)resultTitle;
- (NSString*)resultTitle;

- (void)setLogString:(NSString *)logString;
- (NSString *)logString;
- (void)appendLogString:(NSString *)logString;

- (void)setSearchType:(int)searchType;
- (int)searchType;
- (void)setStartIndex:(int)startIndex;
- (int)startIndex;
- (void)setLastIndex:(int)lastIndex;
- (int)lastIndex;
- (void)setTotalResults:(int)totalResults;
- (int)totalResults;
- (void)setMaxResults:(int)maxResults;
- (int)maxResults;
- (void)setPageIndex:(int)pageIndex;
- (int)pageIndex;
- (void)setPageMaxIndex:(int)pageMaxIndex;
- (int)pageMaxIndex;

@end
